#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/header.c,v 1.4 1999/08/07 00:27:07 kc Exp $")

#include "bb.h"

/* lines, roomname, author, nick, subject, expiration, date, permnumber */
/*  %l      %r       %a      %n     %s       %e          %d    %p */

/* virtual current, virtual last, repeat char y, repeat string y */
/*     %v               %V           %Rxy           %Rx'y'  */

/* pluralize length, if length greater than x put "LONG" */
/*       %L0                  %Lx      */

/* if length greater than x put string y */
/*                %Lx'y'            */

/* author's current id */
/*          %A         */

#define STANDOUT_MODE  1
#define UNDERLINE_MODE 2

char *actual_format_message_header(header_info, char *, char *);

int header_format_flags;

char *format_message_header(header_info header, char *format)
{
    static char buffer[1000];

    header_format_flags = 0;
    bzero(buffer, sizeof(buffer));
    actual_format_message_header(header, format, buffer);
    return buffer;
}

char *do_single_character(char *to, char from)
{
    if   (header_format_flags & STANDOUT_MODE) {
	    *to++ = from;
	*to++ = '\010';
    }
    if (header_format_flags & UNDERLINE_MODE) {
	*to++ = '_';
	*to++ = '\010';
    }
    *to++ = from;
    return to;
}

void my_strcpy(char *to, char *from)
{
    while (*from) {
	to = do_single_character(to, *from++);
    }
    *to = '\0';
}

char *actual_format_message_header(header_info header, char *format,
				        char *blegga)
{
    char *ptr, *p2;
    int temp_int;

    ptr = blegga;

    while (*format && *format != '\'') {
	if (*format == '%') {
	    switch (*(++format)) {

	    case '@':		/* author's original id, original / current
				 * if different */
		if (istrcmp(header.poster, header.id)== 0) {
		    my_strcpy(ptr, header.poster);
		} else {
		    my_strcpy(ptr, header.poster);
		    ptr = (char *)index(ptr, '\0');
		    *(ptr++) = '/';
		    my_strcpy(ptr, header.id);
		}
		break;

	    case 'A':		/* author's current id */
		my_strcpy(ptr, header.id);
		break;

	    case 'a':		/* author's original id */
		my_strcpy(ptr, header.poster);
		break;

	    case 'd':		/* date posted */
		p2 = (char *)ctime(&header.date);
		*(p2 + 24) = '\0';	/* This is cuz ctime puts a \n after
					 * the string */
		my_strcpy(ptr, p2);
		break;

	    case 'e':		/* expiration date */
		p2 = (char *)ctime(&header.expiration);
		*(p2 + 24) = '\0';	/* This is cuz ctime puts a \n after
					 * the string */
		my_strcpy(ptr, p2);
		break;

	    case 'l':		/* no of lines */
		p2 = (char *)malloc(10);
		sprintf(p2, "%d", header.lines);
		my_strcpy(ptr, p2);
		free(p2);
		break;

	    case 'n':		/* nick */
		my_strcpy(ptr, header.nick);
		break;

	    case 'p':		/* permanent message number */
		p2 = (char *)malloc(10);
		sprintf(p2, "%d", (int)header.number);
		my_strcpy(ptr, p2);
		free(p2);
		break;

	    case 'r':		/* roomname */
		my_strcpy(ptr, Roomname);
		break;

	    case 's':		/* subject */
		my_strcpy(ptr, header.subject);
		break;

	    case 'v':		/* current virtual message number */
		p2 = (char *)malloc(10);
		sprintf(p2, "%d", CurrentMessage);
		my_strcpy(ptr, p2);
		free(p2);
		break;

	    case 'L':		/* Various fun-ness-es with number of lines */
		sscanf(++format, "%d", &temp_int);
		while (*format >= '0' && *format <= '9')
		    format++;
		format--;
		if (!temp_int) {
		    if (header.lines != 1)
			my_strcpy(ptr, "s");
		    else
			*ptr = '\0';
		} else if (*(format + 1) == '\'')
		    if (header.lines > temp_int)
			format = actual_format_message_header(header, format + 2, ptr);

		    else {
			format = (char *)index(format + 2, '\'');
			*ptr = '\0';
		    }
		else if (header.lines > temp_int)
		    my_strcpy(ptr, "LONG");
		else
		    *ptr = '\0';
		break;

	    case 'R':		/* Repeating characters/strings */
		sscanf(++format, "%d", &temp_int);
		while (*format >= '0' && *format <= '9')
		    format++;
		if (*format == '\'') {
		    p2 = (char *)malloc(100);
		    format = actual_format_message_header(header, format + 1, p2);
		    while (temp_int--) {
			my_strcpy(ptr, p2);
			ptr += strlen(p2);
		    }
		    free(p2);
		} else {
		    while (temp_int--)
			ptr = do_single_character(ptr, *format);
		}
		break;

	    case 'V':		/* last virtual message number */
		p2 = (char *)malloc(10);
		sprintf(p2, "%d", Lastmessage);
		my_strcpy(ptr, p2);
		free(p2);
		break;

	    case '-':
		if (*(format + 1) == 'v') {
		    p2 = (char *)malloc(10);
		    sprintf(p2, "%d", Lastmessage - CurrentMessage);
		    my_strcpy(ptr, p2);
		    free(p2);
		    format++;
		}
		break;

	    case '%':		/* percent sign */
		my_strcpy(ptr, "%");
		break;

	    default:
		fprintf(stderr, "Header error: %%%c is not valid.\n", *format);
		;
	    }
	    ptr = (char *)index(ptr, '\0');	/* Advance our pointer to
						 * after what we just added. */
	} else if (*format == '\\') {
	    switch (*(++format)) {
	    case 'l':		/* Control-l (for "more" users) */
		*ptr++ = '\014';
		break;
	    case 'n':		/* Newline */
		*ptr++ = '\n';
		break;
	    case 's':		/* Begin standout mode */
		header_format_flags |= STANDOUT_MODE;
		break;
	    case 't':		/* Tab */
		*ptr++ = '\t';
		break;
	    case 'u':		/* Begin underlining */
		header_format_flags |= UNDERLINE_MODE;
		break;
	    case 'S':
		header_format_flags &= ~STANDOUT_MODE;
		break;
	    case 'U':
		header_format_flags &= ~UNDERLINE_MODE;
		break;
	    case '\\':		/* Backslash */
		my_strcpy(ptr, "\\");
		break;
	    case '\'':		/* single quote */
		my_strcpy(ptr, "\'");
		break;
	    default:
		fprintf(stderr, "Header Error: \\%c is not valid.\n", *format);
	    }
	    ptr = (char *)index(ptr, '\0');
	} else
	    ptr = do_single_character(ptr, *format);
	format++;
    }
    *ptr = '\0';
    return format;
}
