#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/help.c,v 1.4 1999/08/07 00:27:07 kc Exp $")

#include "bb.h"
#include "../lib/misc.h"

#define MAX_TOPICS 100

void help(char *parameter)
{
  FILE *helpfile;
  char line[BUFFERSIZE] = "";
  char params[BUFFERSIZE];
  int opt;
  char *optnames[] = {"hidden", "notitle"};
  enum {hidden_f, notitle_f};
  boolean opts[lengthof(optnames)];

  strcpy(params, parameter);
  for(opt=0; opt<lengthof(opts); opt++) opts[opt] = FALSE;
  while(*params && isopt(*params)) {
    char *word;
    strcpy(params, params+1);
    if((opt=match(word=getword(params), optnames, lengthof(opts)))!=-1) {
      opts[opt] = TRUE;
    } else {
      fprintf(stderr, "unrecognized qualifier /%s\n", word);
      return;
    }
  }
  if(!(helpfile = fopen(tilde(Helpfile), "r"))) {
    fprintf(stderr, "error accessing help text\n");
    return;
  }
  if(!*params) {
    char *topics[MAX_TOPICS];
    int len[MAX_TOPICS];
    char *buf = NULL;
    int i, j, w, lines, buf_l = 0, space_left;

    space_left = BLOCK_SIZE;
    buf = (char *) malloc(space_left);
    while(!feof(helpfile)) {
      int n = 0, width = 0, c = 0;

      page();
      while(fgets(line, sizeof(line), helpfile) && *line == '^')
	fputs(line+1, Page);
      do {
	if(isprint(*line) && *line != ' ' && *line != '^' &&
	   (opts[hidden_f] || *line != '.')) {
	  for(i=0; line[i] && (line[i] != '\n'); i++);
	  line[i] = '\0';
	  len[n] = i;
	  if(i>width) width=i;
	  i++;
	  if(i>space_left) {
	    char *old_buf = buf;
	    space_left = BLOCK_SIZE;
	    buf = (char *) realloc(old_buf, buf_l+space_left);
	    for(j=0; j<n; j++) topics[j] += buf - old_buf;
	  }
	  topics[n] = buf+buf_l;
	  strcpy(topics[n], line);
	  space_left -= i;
	  buf_l += i;
	  n++;
	}
	while(fgets(line, sizeof(line), helpfile) &&
	      !(isprint(*line) && *line != ' '));
      } while (*line != '^' && !feof(helpfile));
      if(n) {
	width += 2;
	c = (Terminal_width-3) / width;
	if(c == 0) c = 1;
	lines = (n + c - 1) / c;
	fprintf(Page, "   ");
	for(i=0; i<lines; i++) {
	  for(j=0; j<c; j++) {
	    fprintf(Page, "%s", topics[j*lines+i]);
	    if((j+1)*lines+i >= n) {
	      fprintf(Page, "\n   ");
	      break;
	    }
	    for(w=len[j*lines+i]; w<width; w++) putc(' ', Page);
	  }
	}
      }
      if(*line == '^') fputs(line+1, Page);
      space_left += buf_l;
      buf_l = 0;
    }
    free(buf);
  } else do {
    char *topic;
    int topic_l, matches = 0;

    if(isopt(*params)) {
      strcpy(params, params+1);
      fprintf(stderr, "unrecognized qualifier /%s\n", getword(params));
      fclose(helpfile);
      return;
    }
    topic = getword(params);
    topic_l = strlen(topic);
    rewind(helpfile);
    while(!feof(helpfile)) {
      if(istrncmp(line, topic, topic_l)==0) {
	if(matches++ == 0) page();
	if(!opts[notitle_f] && (opts[hidden_f] || *line != '.'))
	  fputs(line, Page);
	while(fgets(line, sizeof(line), helpfile) &&
	      !(isprint(*line) && *line != ' ')) {
	  fputs(line, Page);
	}
      } else fgets(line, sizeof(line), helpfile);
    }
    if(!matches) printf("Sorry, there is no help for %s\n", topic);
  } while(*params);
  fclose(helpfile);
}
