#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/list.c,v 1.4 1999/08/07 00:27:10 kc Exp $")

#include "bb.h"

void list(char *parameter)
{
    class_t class = -1, oldclass = -1;
    result_list *users;
    users_info *entry;
    int i, c, opt;
    char group[BUFFERSIZE];
    directory_info *room_info;
    char *optnames[] = {"group"};
    enum {
	group_f
    };
    boolean opts[lengthof(optnames)];
    group_info *group_entry = NULL;

    for (opt = 0; opt < lengthof(opts); opt++)
	opts[opt] = FALSE;
    while (*parameter) {
	if (isopt(*parameter)) {
	    char *word;

	    strcpy(parameter, parameter + 1);
	    if ((opt = match(word = getword(parameter), optnames,
			     lengthof(opts))) != -1) {
		opts[opt] = TRUE;
		switch (opt) {
		case group_f:
		    if (*parameter != '=') {
			fprintf(stderr, "value expected for /%s\n",
				optnames[opt]);
			return;
		    }
		    strcpy(parameter, parameter + 1);
		    strcpy(group, get_group(parameter));
		    break;
		}
	    } else {
		fprintf(stderr, "unrecognized qualifier /%s\n", word);
		return;
	    }
	} else {
	    if (class == -1) {
		char *class_s;

		if ((class = match(class_s = getword(parameter),
				   Classes, lengthof(Classes))) == -1) {
		    fprintf(stderr, "invalid class: '%s'\n", class_s);
		    return;
		}
	    } else {
		fprintf(stderr, "unexpected input: '%s'\n", parameter);
		return;
	    }
	}
    }
    do_connect();
    if (opts[group_f]) {
	if (!(group_entry = get_group_info(group))) {
	    fprintf(stderr, "Error getting group information from server\n%s\n",
		    lib_error);
	    return;
	}
	page();
	fprintf(Page, "Group: %-20s Owner: %-20s Expiration: %d day%s\nPriority: %-17d Default Class: %s\n\n",
		group_entry->name,
		group_entry->owner,
		(int)(group_entry->max_expiration /= 86400),
		group_entry->max_expiration == 1 ? "" : "s",
		(int)group_entry->priority,
		Classes[group_entry->default_class]);
	if (!(users = client_group_list(group))) {
	    fprintf(stderr, "Error getting access list from server\n%s\n",
		    client_error);
	    return;
	}
    } else {
	if (!(room_info = client_roominfo(Roomname))) {
	    fprintf(stderr, "Error getting room information\n%s\n",
		    client_error);
	    return;
	}
	page();
	fprintf(Page, "Room: %-20s Owner: %-20s Expiration: %d day%s\nPriority: %-16d Default Class: %-12s Archive: %s\nGroups: %s\nSummary: %s\n\n",
		room_info->name, room_info->owner,
		(int)(room_info->default_expiration /= 86400),
		room_info->default_expiration == 1 ? "" : "s",
		(int)room_info->priority,
		Classes[room_info->default_class],
		Archives[room_info->archive],
		group_names(&room_info->groups, NULL),
		room_info->summary);
	if (!(users = client_list())) {
	    fprintf(stderr, "Error getting access list from server\n%s\n",
		    client_error);
	    return;
	}
    }
    for (i = 0, c = 0; i < users->count; i++, c++) {
	entry = (users_info *) users->list[i];
	if (class == -1 || class == entry->class) {
	    if (entry->class != oldclass) {
		fprintf(Page, "\n%s:\n", Classes[entry->class]);
		oldclass = entry->class;
		c = 0;
	    } else if (c % 6 == 0)
		fprintf(Page, "\n");
	    fprintf(Page, " %-12s", entry->id);
	}
    }
    fprintf(Page, "\n");
}
