#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/misc.c,v 1.5 1999/08/07 00:27:11 kc Exp $")

#include "bb.h"
#ifdef VMS
#include <lib$routines.h>
#include <descrip.h>
#include <smgmsg.h>
#endif VMS

boolean streqv(char *s1, char *s2)
{
    int i;

    for (i = 0; (s1[i] == s2[i]) && (s1[i] != '\0'); i++);
    return (s1[i] == s2[i]);
}

void printlist(char **list, int count)
{
    int i;

    fprintf(cmdout, "[ ");
    for (i = 0; i < count; i++)
	fprintf(cmdout, "%s ", list[i]);
    fprintf(cmdout, "]\n");
}

char *get_word(char *input, boolean leave_quotes)
{
    static char word[BUFFER_SIZE];
    char *source = input, *dest = word;
    boolean quote = FALSE;

    if (!*input) {
	*word = '\0';
	return word;
    }
 /* skip over leading space */
    while (isspace(*source) && !isend(*source))
	source++;

 /* copy characters */
    while (*source && (quote || iscommand(*source))) {
	if (quote) {
	    if (isquote(*source)) {
		if (leave_quotes)
		    *dest++ = *source;
		source++;
		quote = !quote;
	    } else {
		*dest++ = *source++;
	    }
	} else {
	    if (isquotenext(*source)) {
		if (leave_quotes)
		    *dest++ = *source;
		source++;
		if (*source)
		    *dest++ = *source++;
	    } else if (isquote(*source)) {
		if (leave_quotes)
		    *dest++ = *source;
		source++;
		quote = !quote;
	    } else {
		*dest++ = *source++;
	    }
	}
    }
    *dest = '\0';

 /* skip over trailing space */
    while (isspace(*source) && !isend(*source))
	source++;

 /* put remaining back into input */
    while (*input++ = *source++);
    if (Debug & DEBUG_PARSE)
	fprintf(Debug_file, "word: %s\n", word);
    return word;
}

#ifndef VMS
jmp_buf Prompt_env;

signal_t suspend_prompt()
{
             longjmp(Prompt_env, 1);
    return (signal_t)0;
}

#endif !VMS

char *prompt(char *prompt_string, char *input)
{
    extern boolean Editmode;
    short i;
    boolean tty = isatty(fileno(cmdin));

#ifndef VMS
    signal_t (*old_signal) () = NULL;

    if (setjmp(Prompt_env) == 0) {
	signal_t (*old) ();

	if ((old = signal(SIGTSTP, suspend_prompt)) != suspend_prompt)
	    old_signal = old;
    } else {
	signal(SIGTSTP, old_signal);
	kill(getpid(), SIGTSTP);
	signal(SIGTSTP, suspend_prompt);
    }
#ifdef READLINE
    if (Editmode && tty) {
	char *line, *readline(char *);

	page_end();
	if (!(line = readline(prompt_string))) {
	    signal(SIGTSTP, old_signal);
	    return NULL;
	}
	strcpy(input, line);
	free(line);
    } else {
#endif READLINE
	if (tty) {
	    page_end();
	    printf("%s", prompt_string);
	    rewind(cmdin);
	}
	if (!fgets(input, BUFFER_SIZE, cmdin)) {
	    if (tty && feof(cmdin))
		printf("\n");
	    signal(SIGTSTP, old_signal);
	    return NULL;
	}
#ifdef READLINE
    }
#endif READLINE
    signal(SIGTSTP, old_signal);
    for (i = 0; input[i] && (input[i] != '\n'); i++);
#else
    if (tty) {
	extern int Virtual_Keyboard, Key_Table;
	struct dsc $descriptor_s
	    prompt_d = {strlen(prompt_string), DSC$K_DTYPE_T, DSC$K_CLASS_S,
			prompt_string};
	struct dsc $descriptor_s
	    input_d = {BUFFER_SIZE - 1, DSC$K_DTYPE_T, DSC$K_CLASS_S, input};

	page_end();
	if (smg$read_composed_line(&Virtual_Keyboard, &Key_Table, &input_d,
				     &prompt_d, &i) == SMG$_EOF)
	    return NULL;
    } else {
	if (fgets(input, BUFFER_SIZE, cmdin) == NULL)
	    return NULL;
	for (i = 0; input[i] && (input[i] != '\n'); i++);
    }
#endif VMS
    input[i] = '\0';
    return input;
}

#ifdef VMS
char *getpass(char *prompt)
{
    short i;
    static char password[9];
    extern int Virtual_Keyboard, Key_Table;
    struct dsc $descriptor_s
        prompt_d = {strlen(prompt), DSC$K_DTYPE_T, DSC$K_CLASS_S, prompt};
    struct dsc $descriptor_s
        password_d = {sizeof(password) - 1, DSC$K_DTYPE_T, DSC$K_CLASS_S,
		      password};

    if (smg$read_composed_line(&Virtual_Keyboard, &Key_Table, &password_d,
				 &prompt_d, &i) == SMG$_EOF)
	return NULL;
    password[i] = '\0';
    return password;
}

#endif VMS

char *getline(char *input, boolean leave_quotes)
{
    static char line[BUFFER_SIZE];
    char *source = input, *dest = line;
    boolean quote = FALSE;

    if (!*input) {
	*line = '\0';
	return line;
    }
 /* skip over leading space */
    while (isspace(*source) && !isend(*source))
	source++;

 /* copy characters */
    while (*source && (quote || (!isend(*source) && !isdirect(*source)))) {
	if (quote) {
	    if (isquote(*source)) {
		if (leave_quotes)
		    *dest++ = *source;
		source++;
		quote = !quote;
	    } else {
		*dest++ = *source++;
	    }
	} else {
	    if (isquotenext(*source)) {
		if (leave_quotes)
		    *dest++ = *source;
		source++;
		if (*source)
		    *dest++ = *source++;
	    } else if (isquote(*source)) {
		if (leave_quotes)
		    *dest++ = *source;
		source++;
		quote = !quote;
	    } else {
		*dest++ = *source++;
	    }
	}
    }

 /* truncate trailing space */
    while (dest > line && isspace(*(dest - 1)))
	dest--;
    *dest = '\0';

 /* skip over semi-colon */
    if (*source && isend(*source))
	source++;

 /* skip over trailing space */
    while (isspace(*source) && !isend(*source))
	source++;

 /* put remaining back into input */
    while (*input++ = *source++);

    if (Debug & DEBUG_PARSE)
	printf("line: %s\n", line);
    return line;
}

int ieq(char c1, char c2)
{
    if  (isupper(c1))
	    c1 = tolower(c1);
    if (isupper(c2))
	c2 = tolower(c2);
    return c1 == c2;
}

int match_list(char *input, char **list, int count, boolean abbrev)
{
    char *p, *q;
    int which;

    if (isend(*input))
	return -1;
    for (which = 0; which < count; which++) {
	for (p = input, q = list[which];
	     ieq(*p, *q) && !isend(*p) && *q;
	     p++, q++);
	if (isend(*p) && (abbrev || !*q))
	    return which;
    }
    return -1;
}

void process_message(char *buf, int buf_l)
{
    char *p;

    for (p = buf; p < buf + buf_l; p++) {
	*p &= 0x7f;
	if (iscntrl(*p) && !isspace(*p) &&
	    !(p > buf && p + 1 < buf + buf_l && *p == '\b' &&
	      (*(p - 1) == *(p + 1) || *(p - 1) == '_')))
	/*
	 * If it's an invalid control character, filter it out.  Valid
	 * control characters are isspace(c) (tab, etc.), and a backspace
	 * being used for bolding (between two identical characters) or
	 * underlining (after an underscore, before a normal character). 
	 */
	    *p = '~';
    }
}

static int vnum = -1;

int get_vnum(int pnum)
{
    static int vnum = -1;

    if (vnum < 0 || vnum >= Lastmessage) {
	for (vnum = 0;
	     vnum < Lastmessage && SUMMARY_NUMBER(vnum) < pnum;
	     vnum++);
    } else if (SUMMARY_NUMBER(vnum) == pnum) {
	return vnum + 1;
    } else if (SUMMARY_NUMBER(vnum) < pnum) {
	while (vnum < Lastmessage && SUMMARY_NUMBER(vnum) < pnum)
	    vnum++;
    } else {
	while (vnum >= 0 && SUMMARY_NUMBER(vnum) > pnum)
	    vnum--;
    }
    return (vnum >= 0 && vnum < Lastmessage && SUMMARY_NUMBER(vnum) == pnum)
      ? vnum + 1 : 0;
}

int nearest_vnum(int pnum)
{
    static int vnum = -1;

    if (vnum < 0 || vnum >= Lastmessage) {
	for (vnum = 0;
	     vnum < Lastmessage && SUMMARY_NUMBER(vnum) <= pnum;
	     vnum++);
	vnum--;
    } else if (SUMMARY_NUMBER(vnum) == pnum) {
	return vnum + 1;
    } else if (SUMMARY_NUMBER(vnum) < pnum) {
	while (vnum < Lastmessage && SUMMARY_NUMBER(vnum) <= pnum)
	    vnum++;
	vnum--;
    } else {
	while (vnum >= 0 && SUMMARY_NUMBER(vnum) > pnum)
	    vnum--;
    }
    return MIN(vnum + 1, Lastmessage);
}

char lib_error[BUFFER_SIZE] = "";
int lib_severity = 0;

#ifdef NEED_STRDUP
char *strdup(const char *input)
{
#define MAX_STRDUP (1)
    static char buffer[MAX_STRDUP][BUFFER_SIZE];
    static int i = 0;

    strcpy(buffer[i % MAX_STRDUP], input);
    return buffer[i++ % MAX_STRDUP];
}
#endif

static int get_message_num(char *parameter, int default_message,
			       boolean * permanent)
{
    int message = -1;
    char scratch[BUFFER_SIZE] = "";

    *permanent = FALSE;
    if (!*Roomname) {
	strcpy(lib_error, "No room selected");
	lib_severity = LIB_FATAL;
	return -1;
    }
    if (default_message > 0 && default_message <= Lastmessage)
	message = default_message;
    if (*parameter == '\0')
	return message;
    if (strcmp(parameter, ".") == 0)
	return message;
    if (strcmp(parameter, "$") == 0) {
	if (Lastmessage)
	    return Lastmessage;
	strcpy(lib_error, "There are no messages in this room");
	lib_severity = LIB_ERROR;
	return -1;
    }
    if (*parameter == '#') {
	*permanent = TRUE;
	parameter++;
    }
    message = -1;
    sscanf(parameter, "%d%s", &message, scratch);
    if (message != -1 && (!*scratch || *scratch == ',')) {
	if (*permanent)
	    return message;
	if (message > 0 && message <= Lastmessage)
	    return message;
	sprintf(lib_error, "No such message %d", message);
	lib_severity = LIB_ERROR;
    } else {
	sprintf(lib_error, "Invalid message number %s", parameter);
	lib_severity = LIB_FATAL;
    }
    return -1;
}

int get_message_number(char *parameter, int default_message)
{
    static int start, end, message;
    static boolean perm, range_done = TRUE;
    static char rest[BUFFER_SIZE] = "";
    boolean restart;

    if (!*parameter) {
    /* Optimization for the most common case--empty parameter */
	range_done = TRUE;
	*rest = '\0';
	message = get_message_num(parameter, default_message, &perm);
	if (message == -1)
	    return -1;
	return perm ? message : SUMMARY_NUMBER(message - 1);
    }
    restart = *parameter != ' ';
    if (restart || range_done) {
	char message_s[BUFFER_SIZE], p1[BUFFER_SIZE], p2[BUFFER_SIZE];
	boolean p1_perm, p2_perm;

	if (restart || !*rest)
	    strcpy(message_s, getword(parameter));
	else
	    strcpy(message_s, rest);
	*rest = '\0';
	sscanf(message_s, "%*[^,],%s", rest);
	restart = !*rest;
	if (sscanf(message_s, "%[^-,]-%[^-,]", p1, p2) != 2) {
	    range_done = TRUE;
	    if (!restart && *parameter != ' ') {
		char tmp[BUFFER_SIZE] = " ";

		strcat(tmp, parameter);
		strcpy(parameter, tmp);
	    }
	    if (restart && *parameter == ' ')
		strcpy(parameter, parameter + 1);
	    message = get_message_num(message_s, default_message, &perm);
	    if (message == -1)
		return -1;
	    vnum = message - 1;
	    return perm ? message : SUMMARY_NUMBER(message - 1);
	}
	start = get_message_num(p1, default_message, &p1_perm);
	end = get_message_num(p2, default_message, &p2_perm);
	if (start == -1 || end == -1)
	    return -1;
	if (perm = (p1_perm || p2_perm)) {
	    if (!p1_perm)
		start = SUMMARY_NUMBER(start - 1);
	    if (!p2_perm)
		end = SUMMARY_NUMBER(end - 1);
	}
	message = start;
    }
    restart = (range_done = message == end) && !*rest;
    if (!restart && *parameter != ' ') {
	char tmp[BUFFER_SIZE] = " ";

	strcat(tmp, parameter);
	strcpy(parameter, tmp);
    }
    if (restart && *parameter == ' ')
	strcpy(parameter, parameter + 1);
    vnum = message - 1;
    return start < end ? (perm ? message++ : SUMMARY_NUMBER(message++ - 1))
      : (perm ? message-- : SUMMARY_NUMBER(message-- - 1));
}

char *Date(time_t date)
{
    char *d;

    d = (char *) ctime(&date);
    *(d + 24) = '\0';
    return d;
}

FILE *Page = NULL;

FILE *page()
{
    if (Redirected_output) {
	if (Page != cmdout)
	    page_end();
	Page = cmdout;
    } else if (!Page && *Pager)
	Page = (FILE *) popen(Pager, "w");
    if (!Page) {
	Page = cmdout;
    } else {
	setlinebuf(Page);
    }
    return Page;
}

void page_end()
{
    if (Page && Page != cmdout)
	     pclose(Page);
    Page = NULL;
}

char *get_room(char *input)
{
    result_list *directory;
    static char room[ROOM_SIZE];
    directory_info *entry;
    int which;

    if (*(strcpy(room, getword(input))) == '\0')
	return room;
    if (*Roomname && strcmp(room, ".") == 0)
	strcpy(room, Roomname);
    else if (Abbrev) {
	do_connect();
	if (!(directory = client_directory())) {
	    strcpy(lib_error, client_error);
	    return room;
	}
	which = match_list(room, (char **)directory->list, directory->count,
			   Abbrev);
	if (which != -1) {
	    entry = (directory_info *) directory->list[which];
	    strcpy(room, entry->name);
	}
    }
    if (Debug & DEBUG_PARSE)
	printf("room: %s\n", room);
    return room;
}

char *valid_room(char *input)
{
    result_list *directory;
    static char room[ROOM_SIZE];
    directory_info *entry;
    int which;

    if (*(strcpy(room, input)) == '\0')
	return NULL;
    if (*Roomname && strcmp(room, ".") == 0)
	strcpy(room, Roomname);
    else {
	do_connect();
	if (!(directory = client_directory())) {
	    strcpy(lib_error, client_error);
	    return NULL;
	}
	which = match_list(room, (char **)directory->list, directory->count,
			   Abbrev);
	if (which != -1) {
	    entry = (directory_info *) directory->list[which];
	    strcpy(room, entry->name);
	} else
	    return NULL;
    }
    if (Debug & DEBUG_PARSE)
	printf("valid room: %s\n", room);
    return room;
}

char *get_group(char *input)
{
    result_list *directory;
    static char group[GROUP_SIZE];
    group_info *group_entry;
    int which;

    if (*(strcpy(group, getword(input))) == '\0')
	return group;
    do_connect();
    if (!(directory = client_group_directory())) {
	strcpy(lib_error, client_error);
	return group;
    }
    if ((which = match(group, (char **)directory->list, directory->count))
	!= -1) {
	group_entry = (group_info *) directory->list[which];
	strcpy(group, group_entry->name);
    }
    if (Debug & DEBUG_PARSE)
	printf("group: %s\n", group);
    return group;
}

int get_gid(char *group)
{
    result_list *directory;
    group_info *group_entry;
    int which;

    do_connect();
    if (!(directory = client_group_directory())) {
	strcpy(lib_error, client_error);
	return -1;
    }
    if ((which = match(group, (char **)directory->list, directory->count))
	== -1)
	return -1;
    group_entry = (group_info *) directory->list[which];
    return group_entry->gid;
}

group_info *get_group_info(char *group)
{
    result_list *directory;
    int which;

    do_connect();
    if (!(directory = client_group_directory())) {
	strcpy(lib_error, client_error);
	return NULL;
    }
    if ((which = match(group, (char **)directory->list, directory->count))
	== -1)
	return NULL;
    return (group_info *) directory->list[which];
}

char *literal(char *string)
{
    static char lit[BUFFER_SIZE];
    char *p, *q;

    q = lit;
#ifndef VMS
    *q++ = '\'';
    for (p = string; *p; p++, q++) {
	switch (*p) {
	case '\'':
	    *q++ = '\'';
	    *q++ = '\\';
	    *q++ = '\'';
	default:
	    *q = *p;
	}
    }
    *q++ = '\'';
#else
    *q++ = '"';
    for (p = string; *p; p++, q++) {
	switch (*p) {
	case '"':
	    *q++ = '"';
	default:
	    *q = *p;
	}
    }
    *q++ = '\'';
#endif VMS
    *q = '\0';
    return lit;
}

char *bb_lit(char *string)
{
    static char lit[BUFFER_SIZE];
    char *p, *q;
    boolean okay = *string ? TRUE : FALSE;

    q = lit;
    *q++ = '"';
    for (p = string; *p; p++, q++) {
	okay = okay && iscommand(*p) && !isquotenext(*p) && !isquote(*p);
	switch (*p) {
	case '"':
	    *q++ = '"';
	    *q++ = '\\';
	    *q++ = *p;
	    *q = '"';
	    break;
	default:
	    *q = *p;
	}
    }
    *q++ = '"';
    *q = '\0';
    return okay ? string : lit;
}

#include "../lib/misc.h"

void check_bbrc()
{
    FILE *rc_file;
    extern char Bbrc[];
    char id[BUFFER_SIZE], password[BUFFER_SIZE];
    char passwd[BUFFER_SIZE];

    get_pw(passwd);
    if (rc_file = fopen(tilde(Bbrc), "r")) {
	char input_line[BUFFERSIZE];

	while (fgets(input_line, lengthof(input_line), rc_file)) {
	    char *word = getword(input_line);

	    if (strncmp(word, "signon", 7) == 0 ||
		strncmp(word, "login", 6) == 0) {
		strcpy(id, getword(input_line));
		if (*id &&strcmp(id, Id)!=0)
		    fprintf(cmdout, "\nNote:  the id stored in your bb initialization file (%s)\n       is no longer valid.\n\n", Bbrc);
		strncpy(password, getword(input_line), 8);
		password[8] = '\0';
		if (*password && strcmp(password, passwd) != 0)
		    fprintf(cmdout, "\nNote:  the password stored in your bb initialization file (%s)\n       is no longer valid.\n\n", Bbrc);
		break;
	    }
	}
	fclose(rc_file);
    }
}

void do_connect()
{
    signal_t interrupt();

    int connect_tries = 0;

    while (!client_connected()) {
	if (connect_tries++) {
	    printf("Trying again. . . (Press Control/C to quit.)\n");
#ifdef OBSOLETE
#ifdef VMS
	    signal(SIGINT, (signal_t (*) (int,...))die);
#else
	    signal(SIGINT, die);
#endif VMS
#endif OBSOLETE
	    sleep(5);
	} else
	    printf("\nReconnecting. . .\n\n");
#ifdef VMS
	signal(SIGINT, (signal_t (*) (int,...))interrupt);
#else
	signal(SIGINT, interrupt);
#endif
	signon("/reset");
    }
}

char *group_names(group_set *groups, result_list *group_directory)
{
    static char names[BUFFER_SIZE];
    int i;

    *names = '\0';
    if (!group_directory) {
	group_directory = client_group_directory();
	if (!group_directory) {
	    fprintf(stderr, "%s\n", client_error);
	    return NULL;
	}
    }
    for (i = 0; i < group_directory->count; i++) {
	group_info *group_entry = (group_info *) group_directory->list[i];

	if (GROUP_ISSET(group_entry->gid, groups)) {
	    if (*names)
		strcat(names, ",");
	    strcat(names, group_entry->name);
	}
    }
    return names;
}
