#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/post.c,v 1.4 1999/08/07 00:27:12 kc Exp $")

#define SUBJECT_FIRST
#include "bb.h"
#include <errno.h>

#ifndef VMS
#	define SUCCESSFUL(x) ((x)==0)
#else
#	include <stsdef.h>
#	define signal_t void
#	define SUCCESSFUL(x) $VMS_STATUS_SUCCESS(x)
#endif VMS

extern int errno;
boolean Abort;
jmp_buf Abort_env;

signal_t abort_post()
{
             printf("\n");
    longjmp(Abort_env, 1);
    return (signal_t)0;
}

void post(char *parameter)
{
    char filename[BUFFERSIZE], backupname[BUFFERSIZE], command[BUFFERSIZE];
    char subject[BUFFERSIZE], *buf = NULL;
    int message;
    char old_subject[BUFFERSIZE], new_subject[BUFFERSIZE], *s;
    int buf_l = 0, space_left, newly_read, omask;
    directory_info *room_info;
    FILE *posting;
    int i, old_message = 0;
    boolean cc_output = FALSE, tty;
    signal_t (*old_signal) () = NULL;
    char params[BUFFERSIZE];
    int opt;
    char *optnames[] = {"respond"};
    enum {
	respond_f
    };
    boolean opts[lengthof(optnames)];

    strcpy(params, parameter);
    for (opt = 0; opt < lengthof(opts); opt++)
	opts[opt] = FALSE;
    while (*params && isopt(*params)) {
	char *word;

	strcpy(params, params + 1);
	opt = match(word = getword(params), optnames, lengthof(opts));
	if (opt != -1) {
	    opts[opt] = TRUE;
	    if (*params != '=') {
		fprintf(stderr, "value expected for /%s\n", optnames[opt]);
		return;
	    }
	    strcpy(params, params + 1);
	    switch (opt) {
	    case respond_f:
		message = get_message_number(params, CurrentMessage);
		if (message == -1) {
		    fprintf(stderr, "%s\n", lib_error);
		    return;
		}
		i = get_vnum(message);
		if (!i) {
		    fprintf(stderr, "No such message.\n");
		    return;
		}
		strcpy(old_subject,
		       strncmp(SUMMARY(i - 1)->subject, "Re #", 4) ?
		       SUMMARY(i - 1)->subject :
		       (s = (char *)index(SUMMARY(i - 1)->subject, ':')) ?
		       s + 2 :
		       SUMMARY(i - 1)->subject);
		fprintf(cmdout, "Responding to %s #%d (posted by %s)\n",
			Roomname, message, SUMMARY(i - 1)->poster);
		break;
	    }
	} else {
	    fprintf(stderr, "unrecognized qualifier /%s\n", word);
	    return;
	}
    }
    strcpy(opts[respond_f] ? new_subject : subject, getline(params, FALSE));
    if (*params) {
	fprintf(stderr, "unexpected input: '%s'\n", params);
	return;
    }
    do_connect();
    if (!(room_info = client_roominfo(Roomname))) {
	fprintf(stderr, "Error getting room information\n%s\n", client_error);
	return;
    }
    if (room_info->class < read_write) {
	fprintf(stderr, "permission denied\n");
	return;
    }
#ifdef SUBJECT_FIRST
    if (opts[respond_f]) {
	if (!*new_subject) {
	    fprintf(cmdout, "old subject: %s\n", old_subject);
	    if (!prompt("new subject? ", new_subject))
		return;
	}
	if (!*new_subject)
	    fprintf(cmdout, "old subject kept.\n");
	sprintf(subject, "Re #%d: %s",
		message, *new_subject ? new_subject : old_subject);
    } else {
	if (!*subject && !prompt("subject? ", subject))
	    return;
    }
#endif SUBJECT_FIRST
    if (Redirected_input)
	posting = cmdin;
    else {
#ifndef VMS
	sprintf(filename, "%s/.article", getenv("HOME"));
	sprintf(backupname, "%s~", filename);
#else
	sprintf(filename, "%sarticle.txt", getenv("HOME"));
	sprintf(backupname, "%sarticle.old", getenv("HOME"));
#endif
	rename(filename, backupname);
	if (!*Editor) {
	    posting = cmdin;
	    cc_output = TRUE;
	} else {
	    sprintf(command, "%s %s", Editor, filename);
	    omask = umask(077);
	    if (!SUCCESSFUL(system(command))) {
		umask(omask);
		fprintf(stderr, "\nposting aborted\n");
		return;
	    }
	    umask(omask);
	    fprintf(cmdout, "\n");
	    posting = fopen(filename, "r");
	}
    }
    if (!posting) {
	if (errno == ENOENT)
	    fprintf(stderr, "\nposting aborted\n");
	else
	    perror(filename);
	return;
    }
    if (tty = isatty(fileno(posting))) {
	printf("\n|----- Enter the message text, followed by CTRL/D on a blank line. -----|\n\n");
#ifdef VMS
	old_signal = signal(SIGINT, (signal_t (*) (int,...))abort_post);
#else
	old_signal = signal(SIGINT, abort_post);
#endif VMS
	rewind(posting);
    }
    space_left = BLOCK_SIZE;
    buf = (char *)malloc(space_left);
    if (!buf) {
	perror("malloc");
	Abort = TRUE;
    }
    bzero(buf, space_left);
    if (Abort = setjmp(Abort_env))
	buf_l += strlen(buf + buf_l);
    else {
	while (!feof(posting) &&
	    (newly_read = fread(buf + buf_l, 1, space_left, posting)) > 0) {
	    buf_l += newly_read;
	    space_left -= newly_read;
	    if (space_left == 0) {
		space_left = BLOCK_SIZE;
		buf = (char *)realloc(buf, buf_l + space_left);
		if (!buf) {
		    perror("realloc");
		    Abort = TRUE;
		    break;
		}
		bzero(buf + buf_l, space_left);
	    }
	}
    }
    if (tty) {
	printf("\n");
    }
    if (posting != cmdin)
	fclose(posting);
    if (cc_output && buf_l) {
	omask = umask(077);
	if (posting = fopen(filename, "w")) {
	    fwrite(buf, buf_l, 1, posting);
	    fclose(posting);
	}
	umask(omask);
    }
    if (old_signal) {
#ifdef VMS
	signal(SIGINT, (signal_t (*) (int,...))old_signal);
#else
	signal(SIGINT, old_signal);
#endif VMS
    }
    if (Abort) {
	fprintf(stderr, "posting aborted\n");
	return;
    }
    if (!buf_l) {
	if (Snide)
	    fprintf(cmdout, "Null message body, hope dat's coo'.\n");
	else
	    fprintf(cmdout, "Null message body, hope that's ok.\n");
    }
#ifndef SUBJECT_FIRST
    if (opts[respond_f]) {
	if (!*new_subject) {
	    fprintf(cmdout, "\nOld subject: %s\n", old_subject);
	    if (!prompt("New subject? ", new_subject))
		return;
	}
	if (!*new_subject)
	    fprintf(cmdout, "Old subject kept.\n");
	sprintf(subject, "Re #%d: %s",
		message, *new_subject ? new_subject : old_subject);
    } else {
	if (!*subject) {
	    fprintf(cmdout, "\n");
	    if (!prompt("Subject? ", subject))
		return;
	}
    }
#endif SUBJECT_FIRST
    if (Crypt)
	crypt_message(buf, buf_l);
    do_connect();
    if (client_post(subject, buf, buf_l)) {
	if (Snide)
	    fprintf(cmdout, "message posted.  sigh.\n");
	else
	    fprintf(cmdout, "message posted.\n");
    } else {
	fprintf(stderr, "posting cancelled: %s\n", client_error);
    }
    free(buf);
    if (CurrentMessage > 0)
	old_message = SUMMARY_NUMBER(CurrentMessage - 1);
    update_summary(old_message);
}
