#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/preserve.c,v 1.5 2000/01/30 19:19:23 kc Exp $")

#include "bb.h"

void preserve(char *parameter)
{
  int old_message = 0;
  int i, message;
  char *expiration_s;
  time_t expiration;
  char message_list[8 * 4096];

  if(CurrentMessage>0) old_message = SUMMARY_NUMBER(CurrentMessage-1);
  strcpy(message_list, getword(parameter));
  expiration_s = getword(parameter);
  if(*parameter) {
    fprintf(stderr, "unexpected input: '%s'\n", parameter);
    return;
  }
  if(*expiration_s) {
    char scratch_message_list[8 * 4096] = "", message_s[10];
    
    if(sscanf(expiration_s, "%d", &expiration)!=1) {
      fprintf(stderr, "invalid expiration '%s'\n", expiration_s);
      return;
    }
    expiration *= 86400;
    do_connect();
    while(*message_list) {
      if((message=get_message_number(message_list, CurrentMessage))==-1) {
        fprintf(stderr, "%s\n", lib_error);
        return;
      }
      if(!client_preserve(message, expiration)) {
        fprintf(stderr, "error preserving #%d: %s\n", message, client_error);
	continue;
      }
      sprintf(message_s, "#%d%s", message, *message_list ? "," : "");
      strcat(scratch_message_list, message_s);
    }
    update_summary(old_message);
    strcpy(message_list, scratch_message_list);
  }
  while(*message_list) {
    if((message=get_message_number(message_list, CurrentMessage))==-1) {
      fprintf(stderr, "%s\n", lib_error);
      return;
    }
    if(i = get_vnum(message)) {
      expiration = SUMMARY(i-1)->expiration;
      fprintf(cmdout, "message %d will expire at %s",
	      i, ctime(&expiration));
    } else {
      fprintf(stderr, "message #%d %s.\n",
      	      message, *expiration_s ? "expired" : "not found");
    }
  }
}
