#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/priority.c,v 1.4 1999/08/07 00:27:13 kc Exp $")

#include "bb.h"

void changepriority(char *parameter)
{
  char name[BUFFER_SIZE];
  directory_info *room_entry = NULL;
  group_info *group_entry = NULL;
  char priority_s[BUFFER_SIZE];
  int priority_n;
  int opt;
  char *optnames[] = {"group"};
  enum {group_f};
  boolean opts[lengthof(optnames)];

  for(opt=0; opt<lengthof(opts); opt++) opts[opt] = FALSE;
  while(*parameter && isopt(*parameter)) {
    char *word;
    strcpy(parameter, parameter+1);
    if((opt=match(word=getword(parameter), optnames, lengthof(opts)))!=-1) {
      opts[opt] = TRUE;
    } else {
      fprintf(stderr, "unrecognized qualifier /%s\n", word);
      return;
    }
  }
  do_connect();
  if(*parameter) 
    strcpy(name, opts[group_f] ? get_group(parameter) : get_room(parameter));
  else {
    if(opts[group_f]) {
      prompt("group: ", name);
      strcpy(name, get_group(name));
    } else strcpy(name, Roomname);
  }
  strcpy(priority_s, getword(parameter));
  if(*parameter) {
    fprintf(stderr, "unexpected input: '%s'\n", parameter);
    return;
  }
  if(opts[group_f]) group_entry = get_group_info(name);
  else room_entry = client_roominfo(name);
  if(!*priority_s) {
    if(opts[group_f] ? (char *) group_entry : (char *) room_entry)
      fprintf(cmdout, "%s is set to priority %d.\n", name,
	      opts[group_f] ? group_entry->priority : room_entry->priority);
    else fprintf(stderr, "%s: no such %s\n", name,
		 opts[group_f] ? "group" : "room");
  } else {
    if (sscanf(priority_s, "%d", &priority_n)!=1) {
      fprintf(stderr, "invalid priority %s\n", priority_s);
      return;
    }
    if(opts[group_f] ? client_group_priority(name, priority_n) :
                       client_change_priority(name, priority_n)) {
      fprintf(cmdout, "%s %s changed from priority %d to priority %d.\n",
	      opts[group_f] ? "group" : "room",
	      name,
	      opts[group_f] ? group_entry->priority : room_entry->priority,
	      priority_n);
    } else {
      fprintf(stderr, "%s\n", client_error);
    }
  }
}
