#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/read.c,v 1.4 1999/08/07 00:27:13 kc Exp $")

#include "bb.h"

void readcommand(char *parameter)
{
    int message;

    do {
	if (isopt(*parameter)) {
	    strcpy(parameter, parameter + 1);
	    fprintf(stderr, "unrecognized qualifier /%s\n",
		    getword(parameter));
	    return;
	}
	message = get_message_number(parameter, CurrentMessage);
	if (message == -1) {
	    fprintf(stderr, "%s\n", lib_error);
	    if (lib_severity == LIB_FATAL)
		return;
	    continue;
	}
	if (!readmessage(message, TRUE)) {
	    fprintf(stderr, "Message #%d does not exist.\n", message);
	}
    } while (*parameter);
}

int readmessage(int message, boolean permanent)
{
    header_info header;
    char *buf = NULL;
    int buf_l = 0, i;

    if (message < 1 || Lastmessage < 1 ||
	permanent
	? (message > SUMMARY_NUMBER(Lastmessage - 1))
	: (message > Lastmessage))
	return 0;
    do_connect();
    if (client_read(permanent ? message : SUMMARY_NUMBER(message - 1),
		    &header, &buf, &buf_l)) {
	if (permanent) {
	    for (i = 1;
		 i <= Lastmessage && SUMMARY_NUMBER(i - 1) <= message;
		 i++);
	    CurrentMessage = i - 1;
	} else
	    CurrentMessage = message;
	if (!Redirected_output) {
	/* output to the screen */
	    if (Environment) {
		static char message_id_env[BUFFER_SIZE];

		sprintf(message_id_env, "BB_MESSAGE_ID=%s", header.id);
		putenv(message_id_env);
	    }
	    page();
	    if (Environment)
		putenv("BB_MESSAGE_ID=");
	    fprintf(Page, "%s", format_message_header(header, Header_format));
	    if (Crypt)
		crypt_message(buf, buf_l);
	    process_message(buf, buf_l);
	    fputs(buf, Page);
	/* guarantee final "\n\n" for non-blank posts */
	    if (buf_l >= 1 && buf[buf_l - 1] != '\n')
		fprintf(Page, "\n\n");
	    else if (buf_l >= 2 && buf[buf_l - 2] != '\n')
		fprintf(Page, "\n");
	} else {
	/* output to a file */
	    fprintf(cmdout, "%s",
		    format_message_header(header, File_header_format));
	    if (Crypt)
		crypt_message(buf, buf_l);
	    fputs(buf, cmdout);
	/* guarantee final "\n\n" for non-blank posts */
	    if (buf_l >= 1 && buf[buf_l - 1] != '\n')
		fprintf(cmdout, "\n\n");
	    else if (buf_l >= 2 && buf[buf_l - 2] != '\n')
		fprintf(cmdout, "\n");
	}
	free(buf);
	return 1;
    } else
	return 0;
}
