#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/search.c,v 1.7 2001/01/26 22:06:31 kc Exp $")

#include "bb.h"

char *message_summary(header_info * entry, boolean full, int width);
void oldsearch(char *parameter);

void search(char *parameter)
{
    int opt;
    char *optnames[] = {"subject", "poster", "text", "full", "word",
			"ignore_case", "reverse", "new", "select", "reset",
			"add", "show", "exclude"};
    enum {
	subject, poster, text, full, word_f, ignore_case, reverse, new,
	select, reset, add, show, exclude
    };
    boolean opts[lengthof(optnames)];
    char word[BUFFER_SIZE] = "", line[BUFFER_SIZE], *p;
    header_info *entry;
    int i, j, k, message = -1, old_message = -1;
    result_list *output = NULL;
    static int search_count = 0;
    static char search_room[ROOM_SIZE] = "";
    int *new_entry;
    static int *search_list = NULL, *select_list = NULL;
    int *previous_message_numbers = Message_numbers;
    int old_lastmessage = Lastmessage;

    if (Old_summary) {
	oldsearch(parameter);
	return;
    }
    for (opt = 0; opt < lengthof(opts); opt++)
	opts[opt] = FALSE;
    while (*parameter) {
	if (isopt(*parameter)) {
	    char *word;

	    strcpy(parameter, parameter + 1);
	    opt = match(word = getword(parameter), optnames, lengthof(opts));
	    if (opt != -1) {
		opts[opt] = TRUE;
	    } else {
		fprintf(stderr, "unrecognized qualifier /%s\n", word);
		return;
	    }
	} else {
	    if (!*word) {
		strcpy(word, getword(parameter));
	    } else {
		fprintf(stderr, "unexpected input: '%s'\n", parameter);
		return;
	    }
	}
    }
    if (strcmp(search_room, Roomname) != 0) {
	search_count = 0;
	strcpy(search_room, Roomname);
    }
    do_connect();
    if (Message_numbers == select_list && (opts[reset] || opts[add])) {
	int messagenumber = SUMMARY_NUMBER(CurrentMessage - 1);
	result_list *message_numbers = client_message_numbers(Room_id);

	Lastmessage = message_numbers->count;
	Message_numbers = (int *) message_numbers->list;
	CurrentMessage = nearest_vnum(messagenumber);
    }
    if (!*word && !opts[reset] && !opts[select] && !opts[show])
	prompt("search text: ", word);
    if (*word) {
	int *new_search_list;

	new_search_list = Lastmessage > 0 ? (int *)
	  malloc(Lastmessage * sizeof(*new_search_list)) : NULL;
	if (!opts[select])
	    opts[show] = TRUE;
	if (opts[word_f] || opts[ignore_case]) {
	    char *q = word;

	    strcpy(line, word);
	    if (opts[word_f]) {
		*q++ = '\\';
		*q++ = 'b';
	    }
	    if (opts[ignore_case]) {
		for (p = line; *p; p++) {
		    if (isupper(*p)) {
			*q++ = '[';
			*q++ = *p;
			*q++ = tolower(*p);
			*q++ = ']';
		    } else if (islower(*p)) {
			*q++ = '[';
			*q++ = toupper(*p);
			*q++ = *p;
			*q++ = ']';
		    } else
			*q++ = *p;
		}
	    } else
		for (p = line; *p; *q++ = *p++);
	    if (opts[word_f]) {
		*q++ = '\\';
		*q++ = 'b';
	    }
	    *q = '\0';
	    if (Debug & DEBUG_MISC)
		fprintf(Debug_file, "word = %s\n", word);
	}
	if (!(opts[poster] || opts[subject] || opts[text]))
	    opts[poster] = opts[subject] = opts[text] = TRUE;
	if (opts[text])
	    output = client_search(Roomname, word);
	if (opts[poster] || opts[subject]) {
	    if (p = (char *)re_comp(word)) {
		fprintf(stderr, "%s: %s", word, p);
		opts[poster] = opts[subject] = FALSE;
	    } else if (Lastmessage > 0) {
		load_message_cache(Room_id,
			     SUMMARY_NUMBER(opts[new] ? CurrentMessage : 0),
				   SUMMARY_NUMBER(Lastmessage - 1));
	    }
	}
	for (i = 1, j = 0, k = 0, new_entry = new_search_list;
	     i <= Lastmessage;
	     i++) {
	    entry = SUMMARY(i - 1);
            if (!entry)
                continue;
	    if (opts[text] && entry->number > message && j < output->count)
		message = *((int *)output->list[j++]);
	    if (opts[add] && entry->number > old_message && k < search_count)
		old_message = search_list[k++];
	    if (opts[new] && i <= CurrentMessage)
		continue;
	    if ((opts[add] && entry->number == old_message) ||
		(opts[text] && entry->number == message) ||
		(opts[subject] && re_exec(entry->subject)) ||
		(opts[poster] && (re_exec(entry->poster) ||
				  re_exec(entry->id)))) {
		if (!opts[exclude])
		    *new_entry++ = entry->number;
	    } else {
		if (opts[exclude])
		    *new_entry++ = entry->number;
	    }
	}
	search_count = new_entry - new_search_list;
	if (search_list)
	    free(search_list);
	search_list = Realloc(new_search_list, int, search_count);
    }
    if (opts[select]) {
	int messagenumber = SUMMARY_NUMBER(CurrentMessage - 1);

	select_list = Realloc(select_list, int, search_count);
	bcopy(search_list, select_list, search_count * sizeof(*select_list));
	Lastmessage = search_count;
	Message_numbers = select_list;
	CurrentMessage = nearest_vnum(messagenumber);
    } else if (!opts[reset] && Message_numbers != previous_message_numbers) {
	int messagenumber = SUMMARY_NUMBER(CurrentMessage - 1);

	Lastmessage = old_lastmessage;
	Message_numbers = previous_message_numbers;
	CurrentMessage = nearest_vnum(messagenumber);
    }
    if (opts[show] && search_count > 0) {
	int n;
	    
	page();
	for (i = 1, j = 1; i <= search_count; i++) {
	    n = search_list[i - 1];
	    while (j < Lastmessage && SUMMARY_NUMBER(j - 1) < n)
		j++;
	    if (SUMMARY_NUMBER(j - 1) == n)
		fprintf(Page, "%3d %s\n",
			j, message_summary(SUMMARY(j - 1), opts[full],
					   Terminal_width - 4));
	}
    }
}
