#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/set.c,v 1.5 1999/08/07 00:27:15 kc Exp $")

#include "bb.h"

boolean Abbrev = TRUE;
boolean Crypt = FALSE;
bb_priority Cutoff_priority = 0;
char Debug_filename[BUFFERSIZE] = "";
boolean Editmode = FALSE;
char Editor[BUFFERSIZE] = "";
boolean Environment = FALSE;
char File_header_format[BUFFERSIZE] = "";
char Header_format[BUFFERSIZE] = "";
char Helpfile[BUFFERSIZE] = "";
boolean Hooks = FALSE;
char Id[ID_SIZE] = "";
char Mail_address[BUFFERSIZE] = "";
char Mailer[BUFFERSIZE] = "";
char Nickname[BUFFERSIZE] = "";
boolean No_clobber = FALSE;
boolean Old_summary = OLD_SUMMARY_DEFAULT;
char Pager[BUFFERSIZE] = "";
char Password[ID_SIZE] = "";
char Path[BUFFERSIZE] = "";
int Port_number = PORT_NUMBER;
char Server[BUFFERSIZE] = "";
boolean Snide = FALSE;

long Key = 0;

void set(char *parameter)
{
    char params[BUFFERSIZE];
    char *optnames[] = {"reset", "log", "prompt"};
    enum {
	reset_f, log_f, prompt_f
    };

    char *vars[] = {
		    "abbreviate",
		    "crypt",
		    "cutoff_priority",
		    "debug",
		    "debug_file",
		    "editmode",
		    "editor",
		    "environment",
		    "file_header_format",
		    "header_format",
		    "helpfile",
		    "hooks",
		    "id",
		    "mail_address",
		    "mailer",
		    "nickname",
		    "no_clobber",
		    "old_summary",
		    "pager",
		    "password",
		    "path",
		    "port",
		    "read_timeout",
		    "server",
		    "snide",
		    "write_timeout",
    };

    enum {
	abbreviate_f,
	crypt_f,
	cutoff_f,
	debug_f,
	debug_file_f,
	editmode_f,
	editor_f,
	environment_f,
	file_header_f,
	header_f,
	helpfile_f,
	hooks_f,
	id_f,
	mail_address_f,
	mailer_f,
	nickname_f,
	no_clobber_f,
	old_summary_f,
	pager_f,
	password_f,
	path_f,
	port_f,
	read_timeout_f,
	server_f,
	snide_f,
	write_timeout_f,
    };

    char *debug_names[] = {"transport", "parse", "misc", "other"};
    enum debug_opts {
	transport_f, parse_f, misc_f, other_f
    };

    int opt, tmp;
    boolean opts[lengthof(optnames)], varp[lengthof(vars)];
    boolean varp_all = TRUE;
    char *pager, *editor, *mailer, *header_format, *file_header_format;
    char *helpfile, *word, *path, *server;

    strcpy(params, parameter);
    for (opt = 0; opt < lengthof(opts); opt++)
	opts[opt] = FALSE;
    for (opt = 0; opt < lengthof(varp); opt++)
	varp[opt] = FALSE;
    while (*params) {
	if (isopt(*params)) {
	    strcpy(params, params + 1);
	    if ((opt = match(word = getword(params),
			     optnames, lengthof(opts))) != -1) {
		opts[opt] = TRUE;
	    } else {
		fprintf(stderr, "unrecognized qualifier /%s\n", word);
		return;
	    }
	} else if ((opt = match(word = getword(params),
				vars, lengthof(vars))) != -1) {
	    varp_all = FALSE;
	    if (*params == '=') {
		strcpy(params, params + 1);
		switch (opt) {
		case abbreviate_f:
		    tmp = match(word = getword(params),
				Booleans, lengthof(Booleans));
		    if (tmp == -1) {
			fprintf(stderr,
			     "Value must be true or false, not %s\n", word);
			continue;
		    }
		    Abbrev = tmp;
		    break;
		case crypt_f:{
			char *crypt = getword(params);

			if (*crypt)
			    crypt_setup(crypt);
			Crypt = *crypt != '\0';
			break;
		    }
		case cutoff_f:
		    if (sscanf(word = getword(params), "%d", &tmp) != 1) {
			fprintf(stderr,
			  "Value must be an integer value, not %s\n", word);
			continue;
		    }
		    Cutoff_priority = tmp;
		    break;
		case debug_f:
		    tmp = match(word = getword(params),
				debug_names, lengthof(debug_names));
		    if (tmp == -1) {
			fprintf(stderr,
			 "Value must be a valid debugging option, not %s\n",
				word);
			continue;
		    }
		    Debug |= 1 << tmp;
		    break;
		case debug_file_f:
		    {
			char *input, *filename;
			FILE *file;

			input = getword(params);
			if (!(filename = find_file(input))) {
			    perror(input);
			    continue;
			}
			if (!(file = fopen(filename, "a"))) {
			    perror(filename);
			    continue;
			}
			strcpy(Debug_filename, input);
			Debug_file = file;
		    }
		case editor_f:
		    strcpy(Editor, getword(params));
		    break;
		case editmode_f:
		    tmp = match(word = getword(params),
				Booleans, lengthof(Booleans));
		    if (tmp == -1) {
			fprintf(stderr,
				"Value must be true or false, not %s\n",
				word);
			continue;
		    }
		    Editmode = tmp;
#ifndef READLINE
		    if (Editmode)
			fprintf(stderr,
				"Note: line editing is not currently available on this machine.\n");
#endif READLINE
		    break;
		case environment_f:
		    tmp = match(word = getword(params),
				Booleans, lengthof(Booleans));
		    if (tmp == -1) {
			fprintf(stderr,
			     "Value must be true or false, not %s\n", word);
			continue;
		    }
		    Environment = tmp;
		    break;
		case file_header_f:
		    strcpy(File_header_format, getword(params));
		    break;
		case header_f:
		    strcpy(Header_format, getword(params));
		    break;
		case helpfile_f:
		    strcpy(Helpfile, getword(params));
		    break;
		case hooks_f:
		    tmp = match(word = getword(params),
				Booleans, lengthof(Booleans));
		    if (tmp == -1) {
			fprintf(stderr,
			     "Value must be true or false, not %s\n", word);
			break;
		    }
		    Hooks = tmp;
		    break;
		case id_f:{
			char new_id[BUFFERSIZE];

			strcpy(new_id, getword(params));
			do_connect();
			if (!client_setname(new_id)) {
			    fprintf(stderr, "%s: %s\n", new_id, client_error);
			    continue;
			}
			strcpy(Id, new_id);
			check_bbrc();
			break;
		    }
		case mail_address_f:{
			char new_address[BUFFERSIZE], *i;

			strcpy(new_address, getword(params));
			if (*new_address &&
			    (!(i = (char *)index(new_address, '@')) ||
			     !index(i, '.'))) {
			    fprintf(page(),
				    "\"%s\" does not appear to be a valid internet address.\n",
				    new_address);
			    help(".setmail_address");
			    continue;
			}
			do_connect();
			if (!client_setmail(new_address)) {
			    fprintf(stderr, "%s: %s\n",
				    new_address, client_error);
			    continue;
			}
			strcpy(Mail_address, new_address);
			break;
		    }
		case mailer_f:
		    strcpy(Mailer, getword(params));
		    break;
		case nickname_f:{
			char newnick[BUFFERSIZE];
			user_info *info;
			int max_length = 80 - strlen(Id) -
			9 /* strlen("From:  <>") */ ;
			int length;

			strcpy(newnick, getword(params));
			length = strlen(newnick);
			if (length > max_length) {
			    fprintf(stderr,
			      "That nickname is %d character%s too long.\n",
				    length - max_length,
				    length - max_length == 1 ? "" : "s");
			    continue;
			}
			do_connect();
			if (!client_nick(newnick)) {
			    fprintf(stderr, "%s: %s\n", newnick, client_error);
			    continue;
			}
			if (info = client_whois("")) {
			    char *p, *q = NULL;

			    strcpy(Nickname, info->nick);
			/*
			 * Nicknames have a single trailing space when
			 * they're not empty. This needs to be tossed out for
			 * our Nickname variable. 
			 */
			    for (p = Nickname; *p; p++)
				q = p;
			    if (q)
				*q = '\0';
			}
			break;
		    }
		case no_clobber_f:
		    tmp = match(word = getword(params),
				Booleans, lengthof(Booleans));
		    if (tmp == -1) {
			fprintf(stderr,
			     "Value must be true or false, not %s\n", word);
			continue;
		    }
		    No_clobber = tmp;
		    break;
		case old_summary_f:
		    tmp = match(word = getword(params),
				Booleans, lengthof(Booleans));
		    if (tmp == -1) {
			fprintf(stderr,
			     "Value must be true or false, not %s\n", word);
			continue;
		    }
		    Old_summary = tmp;
		    break;
		case pager_f:
		    strcpy(Pager, getword(params));
		    break;
		case password_f:{
			char password[BUFFERSIZE], verification[BUFFERSIZE];

			strcpy(password, getword(params));
			password[8] = '\0';
			do_connect();
			if (!*password) {
			    strncpy(password,
				    (char *)getpass("new password: "), 8);
			    password[8] = '\0';
			    strncpy(verification,
			       (char *)getpass("retype new password: "), 8);
			    verification[8] = '\0';
			    if (strcmp(password, verification) != 0) {
				fprintf(stderr,
					"mismatch - password unchanged\n");
				continue;
			    }
			}
			if (!client_password(password)) {
			    fprintf(stderr, "%s\n", client_error);
			    continue;
			}
			put_pw(password);
			check_bbrc();
			break;
		    }
		case path_f:
		    strcpy(Path, getword(params));
		    break;
		case port_f:
		    if (sscanf(word = getword(params), "%d", &tmp) != 1) {
			fprintf(stderr,
			  "Value must be an integer value, not %s\n", word);
			continue;
		    }
		    Port_number = tmp;
		    if (*Id)
			signon("/reset");
		    else
			server_close();
		    break;
		case read_timeout_f:
		    if (sscanf(word = getword(params), "%d", &tmp) != 1) {
			fprintf(stderr,
			  "Value must be an integer value, not %s\n", word);
			continue;
		    }
		    Read_timeout = tmp;
		    break;
		case server_f:
		    strcpy(Server, getword(params));
		    if (*Id)
			signon("/reset");
		    else
			server_close();
		    break;
		case snide_f:
		    tmp = match(word = getword(params),
				Booleans, lengthof(Booleans));
		    if (tmp == -1) {
			fprintf(stderr,
			     "Value must be true or false, not %s\n", word);
			continue;
		    }
		    Snide = tmp;
		    break;
		case write_timeout_f:
		    if (sscanf(word = getword(params), "%d", &tmp) != 1) {
			fprintf(stderr,
			  "Value must be an integer value, not %s\n", word);
			continue;
		    }
		    Write_timeout = tmp;
		    break;
		}
		if (opts[log_f])
		    switch (opt) {
		    case abbreviate_f:
			fprintf(cmdout, "%s set to %s\n",
				vars[opt], Booleans[Abbrev]);
			break;
		    case crypt_f:
			fprintf(cmdout, "%s set to %s\n",
				vars[opt], Booleans[Crypt]);
			break;
		    case debug_f:
			fprintf(cmdout, "%s set to:", vars[opt]);
			for (tmp = 0; tmp < lengthof(debug_names); tmp++)
			    if (Debug & (1 << tmp))
				fprintf(cmdout, " %s", debug_names[tmp]);
			fprintf(cmdout, "\n");
			break;
		    case debug_file_f:
			fprintf(cmdout, "%s set to %s\n",
				vars[opt], Debug_filename);
			break;
		    case editmode_f:
			fprintf(cmdout, "%s set to %s\n",
				vars[opt], Booleans[Editmode]);
			break;
		    case editor_f:
			fprintf(cmdout, "%s set to %s\n", vars[opt], Editor);
			break;
		    case environment_f:
			fprintf(cmdout, "%s set to %s\n",
				vars[opt], Booleans[Environment]);
			break;
		    case file_header_f:
			fprintf(cmdout, "%s set to:\n%s\n",
				vars[opt], File_header_format);
			break;
		    case header_f:
			fprintf(cmdout, "%s set to:\n%s\n",
				vars[opt], Header_format);
			break;
		    case helpfile_f:
			fprintf(cmdout, "%s set to %s\n", vars[opt], Helpfile);
			break;
		    case hooks_f:
			fprintf(cmdout, "%s set to %s\n",
				vars[opt], Booleans[Hooks]);
			break;
		    case id_f:
			fprintf(cmdout, "%s set to %s\n", vars[opt], Id);
			break;
		    case mail_address_f:
			fprintf(cmdout, "%s set to %s\n",
				vars[opt], Mail_address);
			break;
		    case mailer_f:
			fprintf(cmdout, "%s set to %s\n", vars[opt], Mailer);
			break;
		    case nickname_f:
			fprintf(cmdout, "%s set to %s\n", vars[opt], Nickname);
			break;
		    case no_clobber_f:
			fprintf(cmdout, "%s set to %s\n", vars[opt],
				Booleans[No_clobber]);
			break;
		    case old_summary_f:
			fprintf(cmdout, "%s set to %s\n", vars[opt],
				Booleans[Old_summary]);
			break;
		    case pager_f:
			fprintf(cmdout, "%s set to %s\n", vars[opt], Pager);
			break;
		    case path_f:
			fprintf(cmdout, "%s set to %s\n", vars[opt], Path);
			break;
		    case port_f:
			fprintf(cmdout, "%s set to %d\n",
				vars[opt], Port_number);
			break;
		    case read_timeout_f:
			fprintf(cmdout, "%s set to %d\n",
				vars[opt], Read_timeout);
			break;
		    case server_f:
			fprintf(cmdout, "%s set to %s\n", vars[opt], Server);
			break;
		    case snide_f:
			fprintf(cmdout, "%s set to %s\n",
				vars[opt], Booleans[Snide]);
			break;
		    case write_timeout_f:
			fprintf(cmdout, "%s set to %d\n",
				vars[opt], Write_timeout);
			break;
		    default:
			fprintf(cmdout, "%s set\n", vars[opt]);
		    }
	    } else {
		varp[opt] = TRUE;
	    }
	} else {
	    fprintf(stderr, "unrecognized parameter: '%s'\n", word);
	    return;
	}
    }

    for (opt = 0; opt < lengthof(varp); opt++)
	if (varp_all || varp[opt]) {
	    if (!opts[reset_f]) {
		switch (opt) {
		case abbreviate_f:
		    fprintf(cmdout, "set %s=%s\n",
			    vars[opt], bb_lit(Booleans[Abbrev]));
		    break;
		case crypt_f:
		    if (!varp_all)
			if (Crypt)
			    fprintf(cmdout, "Encryption enabled.\n");
			else
			    fprintf(cmdout,
				    "Encryption not currently enabled.\n");
		    break;
		case cutoff_f:
		    fprintf(cmdout, "set %s=%d\n", vars[opt], Cutoff_priority);
		    break;
		case debug_f:
		    if (!varp_all && Debug) {
			fprintf(cmdout, "set");
			for (tmp = 0; tmp < lengthof(debug_names); tmp++)
			    if (Debug & (1 << tmp))
				fprintf(cmdout, " %s=%s",
					vars[opt], bb_lit(debug_names[tmp]));
			fprintf(cmdout, "\n");
		    }
		    break;
		case debug_file_f:
		    fprintf(cmdout, "set %s=%s\n",
			    vars[opt], bb_lit(Debug_filename));
		    break;
		case editor_f:
		    fprintf(cmdout, "set %s=%s\n", vars[opt], bb_lit(Editor));
		    break;
		case editmode_f:
		    fprintf(cmdout, "set %s=%s\n",
			    vars[opt], bb_lit(Booleans[Editmode]));
		    break;
		case environment_f:
		    if (!varp_all)
			fprintf(cmdout, "set %s=%s\n",
				vars[opt], bb_lit(Booleans[Environment]));
		    break;
		case file_header_f:
		    if (!varp_all)
			fprintf(cmdout, "set %s=%s\n",
				vars[opt], bb_lit(File_header_format));
		    break;
		case header_f:
		    fprintf(cmdout, "set %s=%s\n",
			    vars[opt], bb_lit(Header_format));
		    break;
		case helpfile_f:
		    if (!varp_all)
			fprintf(cmdout, "set %s=%s\n",
				vars[opt], bb_lit(Helpfile));
		    break;
		case hooks_f:
		    fprintf(cmdout, "set %s=%s\n",
			    vars[opt], bb_lit(Booleans[Hooks]));
		    break;
		case id_f:
		    if (*Id || !varp_all)
			fprintf(cmdout, "set %s=%s\n", vars[opt], bb_lit(Id));
		    break;
		case mail_address_f:
		    if (*Mail_address || !varp_all)
			fprintf(cmdout, "set %s=%s\n",
				vars[opt], bb_lit(Mail_address));
		    break;
		case mailer_f:
		    fprintf(cmdout, "set %s=%s\n", vars[opt], bb_lit(Mailer));
		    break;
		case nickname_f:
		    fprintf(cmdout, "set %s=%s\n",
			    vars[opt], bb_lit(Nickname));
		    break;
		case no_clobber_f:
		    fprintf(cmdout, "set %s=%s\n",
			    vars[opt], bb_lit(Booleans[No_clobber]));
		    break;
		case old_summary_f:
		    if (!varp_all)
			fprintf(cmdout, "set %s=%s\n",
				vars[opt], bb_lit(Booleans[Old_summary]));
		    break;
		case pager_f:
		    fprintf(cmdout, "set %s=%s\n", vars[opt], bb_lit(Pager));
		    break;
		case password_f:
		    if (!varp_all)
			fprintf(cmdout,
				"Use \"set %s=\" to change your password.\n",
				vars[opt]);
		    break;
		case path_f:
		    fprintf(cmdout, "set %s=%s\n", vars[opt], bb_lit(Path));
		    break;
		case port_f:
		    if (!varp_all)
			fprintf(cmdout, "set %s=%d\n", vars[opt], Port_number);
		    break;
		case read_timeout_f:
		    if (!varp_all)
			fprintf(cmdout, "set %s=%d\n",
				vars[opt], Read_timeout);
		    break;
		case server_f:
		    if (!varp_all)
			fprintf(cmdout, "set %s=%s\n",
				vars[opt], bb_lit(Server));
		    break;
		case snide_f:
		    if (!varp_all)
			fprintf(cmdout, "set %s=%s\n",
				vars[opt], bb_lit(Booleans[Snide]));
		    break;
		case write_timeout_f:
		    if (!varp_all)
			fprintf(cmdout, "set %s=%d\n",
				vars[opt], Write_timeout);
		    break;
		}
	    } else {
		switch (opt) {
		case abbreviate_f:
		    Abbrev = TRUE;
		    break;
		case editor_f:
		    if (editor = getenv("BBEDITOR"))
			strcpy(Editor, editor);
		    else if (editor = getenv("EDITOR"))
			strcpy(Editor, editor);
		    else
			*Editor = '\0';
		    break;
		case environment_f:
		    Environment = FALSE;
		    break;
		case file_header_f:
		    if (file_header_format = getenv("BBFILEHEADER"))
			strcpy(File_header_format, file_header_format);
		    else
			strcpy(File_header_format, HEADER_FORMAT);
		    break;
		case header_f:
		    if (header_format = getenv("BBHEADER"))
			strcpy(Header_format, header_format);
		    else
			strcpy(Header_format, HEADER_FORMAT);
		    break;
		case helpfile_f:
		    if (helpfile = getenv("BBHELP"))
			strcpy(Helpfile, helpfile);
		    else
			strcpy(Helpfile, HELPFILE);
		    break;
		case mailer_f:
		    if (mailer = getenv("BBMAILER"))
			strcpy(Mailer, mailer);
		    else if (mailer = getenv("MAILER"))
			strcpy(Mailer, mailer);
		    else
			strcpy(Mailer, MAILER);
		    break;
		case no_clobber_f:
		    No_clobber = FALSE;
		    break;
		case old_summary_f:
		    Old_summary = OLD_SUMMARY_DEFAULT;
		    break;
		case pager_f:
		    if (pager = getenv("BBPAGER"))
			strcpy(Pager, pager);
		    else if (pager = getenv("PAGER"))
			strcpy(Pager, pager);
		    else
			strcpy(Pager, PAGER);
		    break;
		case path_f:
		    if (path = getenv("BBPATH"))
			strcpy(Path, path);
		    else
			*Path = '\0';
		    break;
		case server_f:
		    if (server = getenv("BBSERVER"))
			strcpy(Server, server);
		    else
			strcpy(Server, SERVER);
		    break;
		case port_f:
		    if (word = getenv("BBSERVERPORT")) {
			if (sscanf(word, "%d", &tmp) != 1)
			    fprintf(stderr,
			    "Server port must be an integer value, not %s\n",
				    word);
			else
			    Port_number = tmp;
		    } else {
			Port_number = PORT_NUMBER;
		    }
		    break;
		}
	    }
	}
}
