#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/signon.c,v 1.5 1999/08/07 00:27:17 kc Exp $")

#include "bb.h"
#include "../lib/misc.h"

#define DASHLINE "\n-------------------------------------------------------------------------------\n"
extern char Bbrc[];

void signon(char *parameter)
{
    int                 i;
    boolean             create_flag = FALSE, owner_flag = FALSE;
    char                bbrc[BUFFERSIZE] = "", yesno[BUFFERSIZE] = "";
    char id             [BUFFERSIZE] = "", passwd[BUFFERSIZE] = "";
    FILE               *rc_file;
    int                 opt;
    char               *optnames[] = {"reset"};
    enum {
	reset_f
    };
    boolean             opts[lengthof(optnames)];
    char                params[BUFFERSIZE];
    user_info          *info;

    strcpy(params, parameter);
    for (opt = 0; opt < lengthof(opts); opt++)
	opts[opt] = FALSE;
    while (*params) {
	if (isopt(*params)) {
	    char               *word;

	    strcpy(params, params + 1);
	    if ((opt = match(word = getword(params), optnames, lengthof(opts))) != -1) {
		opts[opt] = TRUE;
		switch (opt) {
		case reset_f:
		    strcpy(id, Id);
		    get_pw(passwd);
		    break;
		}
	    } else {
		fprintf(stderr, "unrecognized qualifier /%s\n", word);
		return;
	    }
	} else {
	    if (!*id)
		strcpy(id, getword(params));
	    else if (!*passwd)
		strcpy(passwd, getword(params));
	    else {
		fprintf(stderr, "unexpected input: '%s'\n", params);
		return;
	    }
	}
    }
    if (*Id) {
	if (!opts[reset_f] && strcmp(Id, id)== 0)
	    return;
	client_signoff();
	if (!opts[reset_f]) {
	    *Id = '\0';
	    put_pw("");
	}
	if (!server_open(Server, Port_number)) {
	    fprintf(stderr, "%s\n", client_error);
	    return;
	}
    }
    while (!*id &&prompt("bb id: ", id)){
	if (create_flag = (strcmp(id, "new")== 0)) {
	    page();
	    fprintf(Page, DASHLINE "Creating a new bb signon" DASHLINE "\n");
	    help(".new_account");
	    if (!prompt("bb id: ", id))
		return;
	}
    }

    if (!*id)
	return;

    if (!strcmp("bb", id) || !strcmp("daemon", id))
	owner_flag = TRUE;

    strncpy(Id, id, ID_SIZE);
    Id[ID_SIZE - 1] = '\0';
    for (i = 0; i < 3 || (exit(1), 0); i++) {
	if (!*passwd)
	    strcpy(passwd, (char *)getpass("bb password: "));
	passwd[8] = '\0';
	put_pw(passwd);

    /*
     * signon 
     */

	if (!client_connected() && !server_open(Server, Port_number)) {
	    fprintf(stderr, "%s\n", client_error);
	    return;
	}
	if (!client_signon(Id, passwd, &Cutoff_priority, create_flag)) {
	    fprintf(stderr, "%s\n", client_error);
	    *passwd = '\0';
	    put_pw(passwd);
	    if (strcmp(client_error, "no signon exists under that id") == 0)
		*Id = '\0';
	    if (strcmp(client_error, "incorrect password") != 0) {
		server_close();
		return;
	    }
	} else
	    break;		/* good password */
    }
    if (info = client_whois("")) {
	char               *p, *q = NULL;

	strcpy(Mail_address, info->mail_address);
	strcpy(Nickname, info->nick);
    /*
     * Nicknames have a single trailing space when they're not empty. This
     * needs to be tossed out for our Nickname variable. 
     */
	for (p = Nickname; *p; p++)
	    q = p;
	if (q)
	    *q = '\0';
    }
    if (*Roomname)
	selectroom(Roomname);
    strcpy(bbrc, tilde(Bbrc));
    if (!(rc_file = fopen(bbrc, "r"))) {
	if (rc_file = fopen(bbrc, "w")) {
	    chmod(bbrc, 0600);
	    fprintf(page(), DASHLINE "Creating bb initialization file (%s)" DASHLINE, bbrc);
	    help(".init_signon");
	    prompt("Include bb password in initialization file? ", yesno);
	    fprintf(rc_file, "# automatically sign %s onto bb\n", Id);
	    if (*yesno == 'y' || *yesno == 'Y') {
		fprintf(page(), "Great, I'll include your password.\n");
		strcpy(id, bb_lit(Id));
		fprintf(rc_file, "signon %s %s\n", id, bb_lit(passwd));
	    } else {
		fprintf(page(), "OK, I'll just write your id--no password.\n");
		fprintf(rc_file, "signon %s\n", bb_lit(Id));
	    }
	    fprintf(rc_file, "# list rooms with new messages\n");
	    fprintf(rc_file, "echo The following rooms have unread messages:\n");
	    fprintf(rc_file, "echo\n");
	    fprintf(rc_file, "directory /messages\n");
	    fclose(rc_file);
	}
    } else
	fclose(rc_file);

    if (create_flag && !owner_flag) {
	goroom("newuser");
	fprintf(page(), DASHLINE "Entering the newuser room\n" DASHLINE);
	help(".newuser_intro");
    }
}
