#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/summary.c,v 1.5 2001/01/26 22:06:31 kc Exp $")

#include "bb.h"

char *message_summary(header_info * entry, boolean full, int width);

void summary(char *parameter)
{
    int i, message;
    header_info *entry = NULL;
    int opt;
    char *optnames[] = {"new", "full", "reverse", "deleted"};
    enum {
	new_f, full_f, reverse_f, deleted_f
    };
    boolean opts[lengthof(optnames)];

    if(Room_id == -1) {
	fprintf(stderr, "no room selected\n");
	return;
    }
    for (opt = 0; opt < lengthof(opts); opt++)
	opts[opt] = FALSE;
    while (*parameter) {
	if (isopt(*parameter)) {
	    char *word;

	    strcpy(parameter, parameter + 1);
	    opt = match(word = getword(parameter), optnames, lengthof(opts));
	    if (opt != -1) {
		opts[opt] = TRUE;
	    } else {
		fprintf(stderr, "unrecognized qualifier /%s\n", word);
		return;
	    }
	} else {
	    message = get_message_number(parameter, CurrentMessage);
	    if (message == -1) {
		fprintf(stderr, "%s\n", lib_error);
		return;
	    }
	    i = nearest_vnum(message);
	    if (!entry)
		page();
	    entry = SUMMARY(i - 1);
            if (!entry)
                continue;
	    if (entry->number != message) {
		fprintf(Page, "\t[message #%d no longer exists]\n", message);
	    } else {
		fprintf(Page, "%c%3d %s\n",
			((i == CurrentMessage) ? '>' : ' '), i,
		    message_summary(entry, opts[full_f], Terminal_width - 5));
	    }
	}
    }

    if (entry)
	return;
    if(!Old_summary)
	load_message_cache(Room_id,
			   SUMMARY_NUMBER(opts[new_f] ? CurrentMessage : 0),
			   SUMMARY_NUMBER(Lastmessage - 1));
    for (i = opts[reverse_f] ?
	 Lastmessage : (opts[new_f] ? CurrentMessage + 1 : 1);

	 opts[reverse_f] ?
	 i >= (opts[new_f] ? CurrentMessage + 1 : 1) : i <= Lastmessage;

	 opts[reverse_f] ? i-- : i++) {
	if (!entry)
	    page();
	entry = SUMMARY(i - 1);
        if (!entry)
            continue;
	if (opts[deleted_f] &&
	    (opts[reverse_f]
	     ? (i < Lastmessage && SUMMARY_NUMBER(i) > entry->number + 1)
	     : (i > 1 && SUMMARY_NUMBER(i - 2) < entry->number - 1)))
	    fprintf(Page, "\t[message deleted]\n");
	fprintf(Page, "%c%3d %s\n",
		i == CurrentMessage ? '>' : ' ', i,
		message_summary(entry, opts[full_f], Terminal_width - 5));
    }
}

char *message_summary(header_info *entry, boolean full, int width)
{
    static char line[BUFFER_SIZE];

    if (!entry)
        strcpy(line, "[message missing]");
    if (full) {
	sprintf(line, "(#%4d) %12.12s %4d [%10.10s] %s",
		entry->number,
		Date(entry->date) + 4,
		entry->lines,
		entry->poster,
		entry->subject);
    } else {
	sprintf(line, "(%12.12s) %4d [%10.10s] %s",
		Date(entry->date) + 4,
		entry->lines,
		entry->poster,
		entry->subject);
    }
    line[width - 1] = '\0';
    return line;
}
