#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/bb/users.c,v 1.4 1999/08/07 00:27:18 kc Exp $")

#include "bb.h"

void users(char *parameter)
{
    result_list *users;
    user_list_info *user;
    int i, opt, c = 0, field_width;
    char *dot, tmp[BUFFER_SIZE];
    char *formats[] = {"nicknames", "brief", "full", "protocol"};
    enum {
	nicknames_f, brief_f, full_f, protocol_f
    }    format;

    format = nicknames_f;
    while (*parameter) {
	if (isopt(*parameter)) {
	    char *word;

	    strcpy(parameter, parameter + 1);
	    if ((opt = match(word = getword(parameter), formats, lengthof(formats))) != -1) {
		format = opt;
	    } else {
		fprintf(stderr, "unrecognized qualifier /%s\n", word);
		return;
	    }
	} else {
	    fprintf(stderr, "unexpected input: '%s'\n", parameter);
	    return;
	}
    }
    do_connect();
    if (!(users = client_users())) {
	fprintf(stderr, "Error getting list of users from server\n%s\n",
		client_error);
	return;
    }
    page();
    for (i = 0; i < users->count; i++) {
	user = (user_list_info *) users->list[i];
	switch (format) {
	case brief_f:
	    field_width = strlen(user->id);
	    if (c + 1 + field_width >= Terminal_width) {
		fprintf(Page, "\n");
		c = 0;
	    }
	    if (c != 0) {
		fprintf(Page, " ");
		c++;
	    }
	    fprintf(Page, "%s", user->id);
	    c += field_width;
	    break;
	case full_f:
	case protocol_f:
	    if (user->slot != -1)
		fprintf(Page, "(%2d) ", user->slot);
	    else
		fprintf(Page, "     ");
	    sprintf(tmp, "<%s>", user->id);
	    tmp[14] = user->address[34] = '\0';
	    fprintf(Page, "%2d:%02d %-14s %s",
		    user->idle / 60, user->idle % 60, tmp, user->address);
	    switch (format) {
	    case full_f:
		if (*user->room) {
		    sprintf(tmp, "%%-%ds", 34 - strlen(user->address));
		    fprintf(Page, tmp, "");
		    fprintf(Page, " (%s)", user->room);
		}
		break;
	    case protocol_f:
		sprintf(tmp, "%%-%ds", 34 - strlen(user->address));
		fprintf(Page, tmp, "");
		fprintf(Page, " %d.%d",
			user->major_version, user->minor_version);
		break;
	    }
	    fprintf(Page, "\n");
	    break;
	default:
	    if (index(user->address, '[') == 0 &&
		(dot = (char *)index(user->address, '.')))
		*dot = '\0';
	    fprintf(Page, "(%s) %s<%s>\n",
		    user->address, user->nick, user->id);
	    break;
	}
    }
    if (format == brief_f && c != 0)
	fprintf(Page, "\n");
}
