.hx
.nr PD 1v
.pl 11i
.m1 .1i
.m2 .5i
.eh ~UNIX/bb~%~UCS~
.oh ~UCS~%~UNIX/bb~
\" .nf
\" ---------------------------------------------------- UNIX/bb
\" File Name: bb
\" Topic: Using BB
\" Date: April 16, 1991
\" .DA April 16, 1991
\" ------------------------------------------------------------
\" Operating System: UNIX
\" ------------------------------------------------------------
\" .fi
.sp 1
.DS C
.LG
.LG
.LG
Using BB
.NL
.DE
.LP
.sp 1
.KS
.DS C
.B Introduction
.DE
.SH
Purpose
.LP
This bulletin board is provided as a service by the University of
Washington's Computing & Communications division in support of the
University's commitment to promoting:
.RS
.IP * 3
the free interchange of information about information technology
.IP *
the application of the technology to education and research
.IP *
a forum for discussion of University related activities and pursuits
.IP *
a vehicle for open discussion on topics of interest to the community
.RE
.LP
in a context which supports:
.RS
.IP * 3
the constructive expression of ideas, and
.IP *
understanding, respect for and appreciation of human differences.
.RE
.KE
.LP
As a new user, you are advised to read this document before proceeding
further in
.B bb .
Command reference is available within
.B bb
via the
\fBhelp\fP command.
.SH
Ethics
.LP   
The use of this bulletin board is a privilege -- not a right.  Users are
reminded that the content of postings are subject to federal and state laws
as well as University policies on sexual, racial and religious harassment,
misuse of University property, and discrimination based on age, veteran
status, gender, sexual orientation, race, ethnic origin or marital status --
regardless of the \*Qhistorical culture\*U of the room in which a message is
posted.
.RS
\fB
.LP
Failure to comply with these laws and policies could result in
disciplinary actions including, but not limited to, suspension
or permanent dismissal from the University, civil prosecution,
and/or personal liability.
\fP
.RE
.LP
Complaints regarding alleged student misconduct should be directed to
the Office of the Vice President for Student Affairs at (206) 543-4972;
alleged incidents of faculty or staff misconduct should be reported to the
Human Rights Office, (206) 543-7217.
.sp 1
.KS
.DS C
.B "Accessing BB"
.DE
.SH
Connecting to
.B bb
.LP
To
connect to
.B bb
enter the command:
.DS

bb

.DE
on any of the UCS 
.SM
UNIX
.NL
machines.
.KE
.KS
.SH
Signing on
.LP
When you connect to
.B bb
you will see the following message:
.KE
.DS

Welcome to BB.

bb id:

.DE
If you have already established a
.B bb
signon, enter your id at this
prompt, and your password at the \*Qpassword\*U prompt that follows.  If
not, enter \*Qnew\*U as your id.  This will produce the following:
.DS

Welcome to BB.

bb id: \fBnew\fP

Creating a new bb signon.  Enter an unused id and password.

bb id:
	.
	.
	.
bb password:

.DE
.LP
At the \*Qid\*U and \*Qpassword\*U prompts, enter any new
.B bb
id and password you wish.  The id and password you choose need not be
the same as your system id or password.  To change your id or password
later, use the \fBsetname\fP or \fBpassword\fP commands within
.B bb .
.sp 1
.KS
.DS C
.B "Getting Around"
.DE
.SH
Architecture
.LP
In
.B bb ,
messages are posted in rooms; each room addresses a specific
topic.  All rooms are in one of two groups: \*Qsupported\*U and
\*Qunsupported.\*U  The supported group contains those rooms supported
by University Computing Services.  Unsupported rooms are initially
hidden from view, and messages within those rooms expire more quickly
than those in the supported rooms.
.KE
.KS
.SH
Rooms:  Priorities and Access
.LP
By default, rooms are accessible by everyone.  However, they can be
assigned the class \fBno_access\fP by their owner.  If they have this
class, only those specified by the owner can ever see the room.
.KE
.LP
Rooms are sorted by their priority, which is a number assigned to
individual rooms and groups.  A room assigned a higher priority comes
before a room with a lower priority; rooms assigned the same priority
are sorted alphabetically.
.LP
A room's priority is determined by the highest priority of the groups
in which that room is a member, and an individual offset for the
room's priority.  To change the priority of a room, use the
\fBpriority\fP command, and specify what you would like the room's new
priority to be:
.B bb
will compute the appropriate offset for the room.  For example,
.DS

bb> \fBpriority unix*hints 50\fP

.DE
sets the priority of the \*Qunix*hints\*U room to 50 (regardless of the
groups of which unix*hints happens to be a member).
.LP
There is a configurable cutoff priority, which is initially set to 0.
All rooms with priorities below the cutoff are hidden.  Those with
higher priorities are (if accessible) automatically visible.  To
change your cutoff priority, use the \fBcutoff\fP command.
.LP
By default, only the rooms in the supported group are visible.  The
\fBpriority /group\fP command changes a group's priority.  To see the
rooms in the unsupported group, set its priority to a number above
your cutoff, e.g.,
.DS

bb> \fBpriority /group unsupported 0\fP

.DE
.LP
For more information, see the internal help.
.KS
.SH
Directory
.LP
The \fBdirectory\fP command shows a list of all the visible, accessible
rooms.  If messages have been posted in a room following the last
message you've read in that room, it will be flagged with an asterisk.
The currently selected room is flagged with \*Q>\*U.
There are various qualifiers (type \fBdirectory /\fP<qualifier>) that
modify directory's output.  The most commonly used are:
.KE
.IP
.RS
.IP \fB/count\fP 15
displays the number of messages posted in each room following the last
message read in that room
.IP \fB/full\fP
displays each room's summary line and owner as well as the standard
room name
.IP \fB/messages\fP
lists only those rooms in which messages have been posted since the
last message you've read
.IP \fB/priorities\fP
displays room priorities
.RE
.LP
For a complete list of qualifiers, see the internal help.
.KS
.SH
Selecting rooms
.LP
When you enter
.B bb ,
you are placed in the first room in your directory
which contains new messages (see the discussion of priorities, above,
for information on how to re-order your directory).  The command line
prompt always shows which room you are in, the message number you are
at and the total number of messages in a room.  For example,
.DS

bb-general:19/104>

.DE
tells you that you are in the \*Qgeneral\*U room, the 19th message is the
current message, and there are 104 messages in the room.  The current
message is the latest one read.
.KE
.LP
To select a different room to read from and/or post in, use the
\*Q\fBgoto\fP <room-name>\*U command.  For example,
.DS

bb> \fBgoto unix*hints\fP

.DE
selects the \*Qunix*hints\*U room.  You can abbreviate room names to
as few letters as you choose; if what you specify is ambiguous,
.B bb
will select the first matching name in your directory.  For example,
.DS

bb> \fBgoto w\fP

.DE
could select \*Qweather,\*U \*Qwhine,\*U \*Qwhyever,\*U etc.,
depending upon the relative order of these rooms in your directory.
.LP
You may leave off the \fBgoto\fP, as long as the room name doesn't
conflict with a
.B bb
command.  For example, to select the vms*hints
room, you may simply type \*Qvms*hints\*U (or probably even just \*Qvms\*U).
.KS
.SH
Reading messages
.LP
There are several commands for reading messages.  To read the next
message in a room, use the \fBnext\fP command, or just hit the
<return> key.  To read a specific message, type \*Q\fBread\fP <message
number>\*U or simply \*Q<message number>\*U.  (For example, typing
\*Q\fB23\fP\*U will read the 23rd message of the current room.) The
\fBfirst\fP command reads the first message in a room; likewise,
\fBlast\fP reads the last one.  To read the message before the current
one, use \fBback\fP.  \fBAll\fP reads all of the new messages in a
room one right after the other, without a command prompt in between.
.KE
.KS
.SH
Summary
.LP
\fBSummary\fP lists the messages in a room, display for each the message
number, the author and the time of its posting, and its subject line.
To list only those messages posted after the current message, use the
\fB/new\fP qualifier.
.KE
.sp 1
.KS
.DS C
.B "Posting Messages"
.DE
.SH
General instructions for posting a message
.LP
To post a message, use the \fBpost\fP command.  You will be prompted for a
subject line.  Try to make this line relevant and informative: it
should give a brief description of the post's subject matter.
.KE
.LP
There are two ways to post messages: with an editor, and without one.
The latter is easier in the short run, because it does not require you
to learn any editors.  The former is more useful in the long run; you
may change more things, more easily, in your message as you are
writing it.
.LP
If you do not know how to use an editor and would like to learn, the
.SM
UNIX
.NL
manual pages (accessed via the 
.SM
UNIX
.NL
command
.B man )
offer instructions, or documentation can be picked up at a campus
consulting office.
.LP
The editor to be used, if any, is determined by the \fBset editor\fP
command, or by the system environment variables BBEDITOR and EDITOR.
For more information, see \*Qhelp set.\*U  By default,
.B bb
does not use an editor.
.KS
.SH
Posting without an editor
.LP
\fBPost\fP prints a line of instructions to your terminal after you enter
your subject:
.DS

|------Enter your message, followed by CTRL/D on a blank line.------|

.DE
.KE
.LP
Try to end your lines before the vertical bar at the right end of the
instruction line, or many terminals will not be able to read the ends
of them.  You cannot change lines above the one you are on, but you
can edit the line you are typing on, using the standard line editing
keys (for example, the <delete> key).  The arrow keys will not work
on the UNIX version.
.LP
When you've finished your message, type Control-D (or Control-Z, on VMS)
on a blank line. (To type a control character, hold down the <control>
key and press the character.) There are four relevant control
characters if you're not using an editor:
.IP
.RS
.IP \fBControl-D\fP 10
posts your message, when typed on a blank line.
.IP \fBControl-L\fP
marks a new page in your text.  When the message appears on a user's
screen, it will scroll down to the Control-L character and stop.
Hitting the spacebar will give the user the next page of text.
.IP \fBControl-Z\fP
works at any point in
.B bb .
It puts you at your system prompt; you can get back onto
.B bb
with the command
.B fg .
Your message will still be intact, though you will not be able to see
what you have already typed.
.IP \fBControl-C\fP
aborts your message: nothing is posted.
.RE
.LP
.KS
.SH
Posting Files
.LP
To post a file to 
.B bb ,
use the command:
.DS

bb> \fBpost\fP subject \fB<\fP filename

.DE
where \*Qfilename\*U is the name of the file you wish to post.  If you
don't specify a subject on the command line, the first line of the
file will be used as the subject.
.KE
.KS
.SH
Deleting messages
.LP
The \fBdelete\fP command will get rid of unwanted messages that you have
posted; enter \*Q\fBdelete\fP\*U when the message is the current message, or
enter \*Q\fBdelete\fP <message number>\*U to delete the message
specified by <message number>.
.KE
.KS
.SH
Nicknames
.LP
A nickname is a short line of text that appears with your
.B bb
id in messages you post.  To set or change it, use the \fBsetnick\fP
command, which prompts you for your new nickname, and then repeats it
back to you:
.DS

bb> \fBsetnick\fP
nickname? \fBZoology Statistics Consultant\fP
nickname changed to Zoology Statistics Consultant

.DE
.KE
You may also specify your nickname following the setnick command on
the command line, e.g., \*Qsetnick Zoology Statistics Consultant\*U.
.sp 1
.KS
.DS C
.B "Miscellaneous"
.DE
.SH
BB's initialization file
.LP
When
.B bb
starts up, it looks in your home directory for a file named
\*Q.bbrc\*U.  If this file exists, it should contain a set
of commands for
.B bb
to execute as it starts up.  A user's .bbrc file might contain the
following commands:
.DS

signon humboldt ocean
set pager=less
set editor=emacs
users
alias d*ir "directory /messages"
alias hi*de "hide !*; go"
dir

.DE
.KE
.LP
The first line will connect the user (humboldt) to
.B bb
without him having to manually type in his id or password (\*Qocean\*U).
.LP
The second line sets the pager: in this case, 
.B less .
A pager is the program used to display most output from
.B bb .
.LP
The third line defines the editor to be used when posting messages.
Your editor and pager will default to values found in your account's
environment variables, if not specified with \fBset\fP.  (See the
internal help for \fBset\fP for more information.)
.LP
The fourth line, \*Qusers\*U, is a command which lists the users on
.B bb ,
displaying their system ids, their nicknames, and their
.B bb
ids.
.LP
The next two lines in the initialization file define aliases:
.LP
\*Qalias d*ir "directory /messages"\*U sets up an alias so that
\*Qdir\*U invokes the command \*Qdirectory /messages\*U, which
displays a list of all the visible, accessible rooms with new
messages.
.LP
\*Qalias hi*de "hide !*; go"\*U creates an alias so that typing
\*Q\fBhide\fP\*U goes to the next room with new messages after hiding
the room.  The \*Q!*\*U specifies that any arguments to the hide alias
should be inserted at that point in the translation.
.LP
The last line, \*Qdir\*U, invokes the previously defined alias for
directory.
.LP
For more information, see the internal help for \*Q.bbrc\*U.
.KS
.SH
Executing shell commands from within
.B bb
.LP
To execute shell commands while in
.B bb ,
precede your shell command with a \*Q!\*U.  For example,
.DS

bb> \fB!less blegga\fP

.DE
scrolls a file (named \*Qblegga\*U) in your account through less onto your
screen, and then returns you to the
.B bb
command line.  Similarly,
.DS

bb> \fB!prt guide\fP

.DE
will print the file named \*Qguide\*U.
.KE
.LP
(Please note:  in the current implementation, shell commands are
executed by the Bourne shell.  One side-effect of this is that csh and
tcsh aliases will not be translated.)
.KS
.SH
File Manipulation
.LP
\*Q<\*U, \*Q>\*U, and \*Q>>\*U redirect input and output to and from
files for all
.B bb
commands, just as they do in
.SM
UNIX
.NL
shells.  For example,
.DS

bb> \fBall >> bb-support.messages\fP

.DE
appends all messages in the current room to a file named
\*Qbb-support.messages\*U.
.LP
For more information, see the internal help for \*Qfile_manipulation.\*U
.KE
.KS
.SH
Where to go from here
.LP
If you have questions that aren't answered in this documention, try
looking through the internal help, or posting a message in the
\*Qbb*questions\*U room.  If you find a problem with the program, post about
it in the \*Qbugs\*U room.  Suggestions for improving
.B bb
can be posted in the \*Qsuggestions\*U room.
.KE
.KS
.SH
List of help topics
.LP
Internal help is available on the following topics:
.LP
Concepts
.DS
.TS
l l l l .
Commands	Initialization	Header_Format	Parameters
Ethics	File_Manipulation	Message_Number	Special_Effects
.TE
.DE
.LP
Commands
.DS
.TS
l l l l l .
!	changeclass	hide	quit	set
-	create	info	read	show
+	delete	last	remove	signon
add	directory	list	rename	source
alias	echo	mail	reply	subtract
all	exit	next	reset	summary
back	first	post	respond	unalias
catchup	goto	preserve	search	undelete
change	help	priority	run	users
.TE
.DE
.LP
Program Topics
.DS
.TS
l l l l .
Programming	Variables	global	prompt
Macros	do	if	return
Selectors	for	let	while
.TE
.DE
.LP
Type \*Qhelp\*U at the
.B bb
prompt for an up-to-date list of available help topics.
.KE
