#include <sys/types.h>
#include <sys/time.h>
#include <stdio.h>
#ifdef NeXT
#include <libc.h>
#endif
#include "../lib/config.h"
#include "../lib/types.h"
#include "../lib/client.h"
#include "../bb/config.h"

#define BLOCK_SIZE (4096)

#ifndef FALSE
#define FALSE (0)
#endif FALSE

void main(int argc, char *argv[])
{
  char *buf, *nick;
  int buf_l, space_left, newly_read;
  int hidden_priority;
  int message_number, rid;

  argc--;
  if(argc<3 || argc>4) {
    printf("usage: %s <server> <room> <subject> [<nick>]\n", argv[0]);
    return;
  }
  if(!server_open(argv[1], PORT_NUMBER)) {
    printf("error connecting to server: %s\n", client_error);
    return;
  }
  if(!client_signon("daemon", "blegga;", &hidden_priority, FALSE)) {
    printf("error signing on: %s\n", client_error);
    return;
  }
  if(!client_select(argv[2], &message_number, &rid)) {
    printf("error selecting on: '%s': %s\n", argv[2], client_error);
    return;
  }
  if(argc==4) nick = argv[4];
  else nick = "";
  if(!client_nick(nick)) {
    printf("warning: error setting nickname: %s\n", client_error);
  }
  space_left = BLOCK_SIZE;
  buf = (char *) malloc(space_left);
  buf_l = 0;
  while((newly_read=read(0, buf+buf_l, space_left)) > 0) {
    buf_l += newly_read;
    space_left -= newly_read;
    if(space_left==0) {
      space_left = BLOCK_SIZE;
      buf = (char *) realloc(buf, buf_l+space_left);
    }
  }
  if(!client_post(argv[3], buf, buf_l)) {
    printf("error posting message: %s\n", client_error);
  }
  if(!client_nick("")) {
    printf("warning: error setting nickname: %s\n", client_error);
  }
  if(!client_signoff()) printf("error signing off: %s\n", client_error);
}
