#include "types.h"

/* For transport routines */

extern int Debug;
extern FILE *Debug_file;
extern int Read_timeout, Write_timeout;

#define BUFFER_SIZE 512

extern char client_error[BUFFER_SIZE];

typedef struct {
  void **list;
  int count;
} result_list;

void block();
void unblock();
int read_server_code(int *code);
int write_server_code(int code);
int server_open(const char *server_hostname, int server_port);
void server_close();
void server_flush();
int client_connected();
int client_protocol();
int client_signon(const char *id, const char *passwd,
		  bb_priority *hidden_priority, boolean create);
int client_test();

int client_changeclass(const char *id, class_t class);
int client_changeroom(const char *room,
		      const char *owner,
		      const time_t *default_expiration,
		      const class_t *default_class,
		      const char *summary_line,
		      const bb_priority *priority,
		      const bb_archive_t *archive);
int client_create(const char *room, const char *summary);
int client_delete(int messagenumber);
result_list *client_directory();
void client_directory_flush();
int client_change_priority(const char *room, bb_priority priority);
int client_shutdown(boolean reboot, boolean now);
result_list *client_users();
int client_nick(char *nick);
int client_password(const char *password);
int client_post(const char *room, const char *buf, int buf_l);
int client_read(int messagenumber, header_info *header,
		char **buf, int *buf_l);
int client_remove(const char *room);
directory_info *client_roominfo(const char *room);
int client_select(const char *input_room, int *messagenumber, int *rid);
int client_signoff();
result_list *client_summary();
result_list *client_list();
user_info *client_whois(const char *id);
int client_cutoff(bb_priority priority);
int client_preserve(int messagenumber, time_t new_expiration);
int client_group_add(const char *group, const char *room);
int client_group_subtract(const char *group, const char *room);
int client_group_create(const char *group);
int client_group_remove(const char *group);
int client_group_changeclass(const char *group, const char *id, class_t class);
int client_setname(const char *new_id);
int client_rename(const char *new_name);
int client_group_change(const char *group, const char *name, const char *owner,
			const class_t *default_class,
			const bb_priority *priority,
			const time_t *max_expiration);
int client_setmail(const char *new_address);
int client_setcurrent(int messagenumber);
int client_kill(int slot);
int client_undelete(int messagenumber);
result_list *client_group_directory();
result_list *client_search(const char *room, const char *regexp);
result_list *client_group_list(const char *group);
header_info *get_message_entry(int rid, int message);
result_list *client_message_numbers(int rid);
boolean load_message_cache(int rid, int start_message, int end_message);
boolean read_message_cache(int rid, int start_message, int end_message);
