#include "../rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/lib/client/group_change.c,v 1.4 1999/08/07 00:25:57 kc Exp $")

#include "header.h"

int client_group_change(const char *group, const char *name, const char *owner,
			const class_t *default_class,
			const bb_priority *priority,
			const time_t *max_expiration)
{
  int code;

  block();
  write_server_code(CLIENT_GROUPCHANGE);

  write_socket_string(server_socket, group);
  if(name) write_socket_string(server_socket, name);
  else write_socket_string(server_socket, "");
  if(owner) write_socket_string(server_socket, owner);
  else write_socket_string(server_socket, "");

  if(default_class) write_socket_int(server_socket, *default_class);
  else write_socket_int(server_socket, -1);

  if(priority)
    if(*priority>=0) write_socket_int(server_socket, *priority+1);
    else write_socket_int(server_socket, *priority);
  else write_socket_int(server_socket, 0);

  if(max_expiration) write_socket_int(server_socket, *max_expiration);
  else write_socket_int(server_socket, -1);

  read_server_code(&code);
  unblock();
  return code==SERVER_ACK;
}
