#include "../rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/lib/client/group_directory.c,v 1.5 1999/08/07 00:25:58 kc Exp $")

#include <stdlib.h> // For malloc, qsort
#include "header.h"

static int group_order(const void *, const void *);

result_list *client_group_directory()
{
    static result_list result;
    static group_info *list[MAX_GROUPS];
    group_info **entry;
    int code;

    block();
    write_server_code(CLIENT_GROUPDIRECTORY);
    if (!read_server_code(&code)) {
	unblock();
	return NULL;
    }
    if (code == SERVER_NAK) {
	unblock();
	return &result;
    }
    result.count = 0;
    result.list = (void **)list;
    entry = list;
    while (code == SERVER_ACK) {
	if (!*entry)
	    *entry = (group_info *) malloc(sizeof(group_info));
	read_socket(server_socket, (*entry)->name, sizeof((*entry)->name));
	read_socket(server_socket, (*entry)->owner, sizeof((*entry)->owner));
	read_socket_int(server_socket, (int *)&(*entry)->default_class);
	read_socket_int(server_socket, (int *)&(*entry)->max_expiration);
	read_socket_int(server_socket, (int *)&(*entry)->priority);
	read_socket_int(server_socket, (int *)&(*entry)->class);
	read_socket_int(server_socket, (int *)&(*entry)->gid);
	result.count++;
	entry++;
	if (!read_server_code(&code)) {
	    unblock();
	    return NULL;
	}
    }
    unblock();
    if (code != SERVER_EOF)
	return NULL;
    qsort(list, result.count, sizeof(group_info *), group_order);
    return &result;
}

static int group_order(const void *p1, const void *p2)
{
    const group_info * const *gi1 = p1;
    const group_info * const *gi2 = p2;
    int order;

    order = (*gi2)->priority - (*gi1)->priority;
    if (!order)
	order = istrcmp((*gi1)->name, (*gi2)->name);
    return order;
}
