#include "../rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/lib/client/group_list.c,v 1.4 1999/08/07 00:25:58 kc Exp $")

#include <stdlib.h> // For malloc, qsort
#include "header.h"

result_list *client_group_list(const char *group)
{
    static result_list result;
    static users_info *list[MAX_USERS];
    users_info **entry;
    int code;

    block();
    write_server_code(CLIENT_GROUPLIST);
    write_socket_string(server_socket, group);
    if (!read_server_code(&code)) {
	unblock();
	return NULL;
    }
    if (code == SERVER_NAK) {
	unblock();
	return &result;
    }
    result.count = 0;
    result.list = (void **)list;
    entry = list;
    while (code == SERVER_ACK) {
	if (!*entry)
	    *entry = (users_info *) malloc(sizeof(users_info));
	read_socket(server_socket, (*entry)->id, sizeof((*entry)->id));
	read_socket_int(server_socket, (int *)&(*entry)->priority);
	read_socket_int(server_socket, (int *)&(*entry)->class);
	result.count++;
	entry++;
	if (!read_server_code(&code)) {
	    unblock();
	    return NULL;
	}
    }
    unblock();
    if (code != SERVER_EOF)
	return NULL;
    qsort(list, result.count, sizeof(users_info *), list_order);
    return &result;
}
