#include "../rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/lib/client/list.c,v 1.5 1999/08/07 00:26:00 kc Exp $")

#include <stdlib.h> // For malloc, qsort
#include "header.h"

result_list *client_list()
{
    static result_list result;
    static users_info *list[MAX_USERS];
    users_info **entry;
    int code;

    block();
    write_server_code(CLIENT_LIST);
    if (!read_server_code(&code)) {
	unblock();
	return NULL;
    }
    if (code == SERVER_NAK) {
	unblock();
	return &result;
    }
    result.count = 0;
    result.list = (void **)list;
    entry = list;
    while (code == SERVER_ACK) {
	if (!*entry)
	    *entry = (users_info *) malloc(sizeof(users_info));
	read_socket(server_socket, (*entry)->id, sizeof((*entry)->id));
	read_socket_int(server_socket, (int *)&(*entry)->last_message_read);
	read_socket_int(server_socket, (int *)&(*entry)->priority);
	read_socket_int(server_socket, (int *)&(*entry)->class);
	result.count++;
	entry++;
	if (!read_server_code(&code)) {
	    unblock();
	    return NULL;
	}
    }
    unblock();
    if (code != SERVER_EOF)
	return NULL;
    qsort(list, result.count, sizeof(users_info *), list_order);
    return &result;
}

int list_order(const void *p1, const void *p2)
{
    const users_info * const *ui1 = p1;
    const users_info * const *ui2 = p2;
    int order;

    order = (*ui2)->class - (*ui1)->class;
    if (!order)
	order = istrcmp((*ui1)->id, (*ui2)->id);
    return order;
}
