#include "../rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/lib/client/message_numbers.c,v 1.4 1999/08/07 00:26:01 kc Exp $")

#include <stdlib.h> // For malloc, realloc, free
#include "header.h"

#define EXTEND_COUNT 100

result_list *client_message_numbers(int rid)
{
    static result_list result;
    static int *list = NULL;
    static int list_size = 0;
    int code, count = 0;
    int range_start, range_end;

    block();
    write_server_code(CLIENT_MESSAGE_NUMBERS);
    write_socket_int(server_socket, rid);
    if (!read_server_code(&code)) {
	unblock();
	return NULL;
    }
    if (code == SERVER_NAK) {
	unblock();
	return &result;
    }
    while(code == SERVER_MESSAGE_SINGLE || code == SERVER_MESSAGE_RANGE) {
	switch(code) {
	case SERVER_MESSAGE_SINGLE:
	    if (count >= list_size) {
		list_size += EXTEND_COUNT;
		list = Realloc(list, int, list_size);
		bzero(list + list_size - EXTEND_COUNT,
			EXTEND_COUNT * sizeof(*list));
	    }
	    read_socket_int(server_socket, &list[count++]);
	    break;
	case SERVER_MESSAGE_RANGE:
	    read_socket_int(server_socket, &range_start);
	    read_socket_int(server_socket, &range_end);
	    while(range_start <= range_end) {
		if (count >= list_size) {
		    list_size += EXTEND_COUNT;
		    list = Realloc(list, int, list_size);
		    bzero(list + list_size - EXTEND_COUNT,
			  EXTEND_COUNT * sizeof(*list));
		}
		list[count++] = range_start++;
	    }
	    break;
	}
	if (!read_server_code(&code)) {
	    unblock();
	    return NULL;
	}
    }
    unblock();
    if (code != SERVER_EOF)
	return NULL;
    result.count = count;
    result.list = (void **)list;
    return &result;
}
