#include "../rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/lib/client/search.c,v 1.4 1999/08/07 00:26:03 kc Exp $")

#include <stdlib.h> // For malloc, realloc, free
#include "header.h"

#define EXTEND_COUNT 100

result_list *client_search(const char *room, const char *regexp)
{
    static result_list result;
    static int **list = NULL;
    static int list_size = 0;
    int code, i;

    block();
    write_server_code(CLIENT_SEARCH);
    write_socket_string(server_socket, room);
    write_socket_string(server_socket, regexp);
    if (!read_server_code(&code)) {
	unblock();
	return NULL;
    }
    for(i = 0; code == SERVER_ACK; i++) {
	if (i >= list_size) {
	    list_size += EXTEND_COUNT;
	    list = Realloc(list, int *, list_size);
	    bzero(list + list_size - EXTEND_COUNT,
		  EXTEND_COUNT * sizeof(*list));
	}
	if (!list[i])
	    list[i] = (int *)malloc(sizeof(*list[i]));
	read_socket_int(server_socket, list[i]);
	if (!read_server_code(&code)) {
	    unblock();
	    return NULL;
	}
    }
    unblock();
    if (code != SERVER_EOF)
	return NULL;
    result.count = i;
    result.list = (void **)list;
    return &result;
}
