#include "../rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/lib/client/signon.c,v 1.4 1999/08/07 00:26:06 kc Exp $")

#include "header.h"

uid_t getuid(void);

int client_signon(const char *id, const char *passwd,
		  bb_priority *hidden_priority, boolean create)
{
    int code;
    char user[32];

    if (!valid_id(id)) {
	strcpy(client_error, "Invalid id");
	return 0;
    }
    bzero(user, sizeof(user));
#ifndef VMS
    strcpy(user, (*getpwuid(getuid())).pw_name);
#else
    downcase(user, (char *)getenv("USER"));
#endif VMS
    block();
    write_server_code(CLIENT_SIGNON);
    write_socket_string(server_socket, user);
    write_socket_string(server_socket, id);
    write_socket_string(server_socket, passwd);
    write_server(&create, sizeof(create));
    read_server_code(&code);
    if (code == SERVER_ACK) {
	read_socket_int(server_socket, (int *) hidden_priority);
    } else
	server_close();
    unblock();
    client_directory_flush();
    return code == SERVER_ACK;
}
