#include "../rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/lib/client/summary.c,v 1.4 1999/08/07 00:26:06 kc Exp $")

#include <stdlib.h> // For malloc, realloc, free
#include "header.h"

#define EXTEND_COUNT 100

result_list *client_summary()
{
    static result_list result;
    static header_info **list = NULL;
    static int list_size = 0;
    header_info **entry;
    int code, i;

    block();
    write_server_code(CLIENT_SUMMARY);
    if (!read_server_code(&code)) {
	unblock();
	return NULL;
    }
    if (code == SERVER_NAK) {
	unblock();
	return &result;
    }
    for (i=0; code == SERVER_ACK; i++) {
	if (i >= list_size) {
	    list_size += EXTEND_COUNT;
	    list = Realloc(list, header_info *, list_size);
	    bzero(list + list_size - EXTEND_COUNT,
		  EXTEND_COUNT * sizeof(*list));
	}
	entry = list + i;
	if (!*entry)
	    *entry = (header_info *) malloc(sizeof(**entry));
	read_socket_int(server_socket, (int *)&(*entry)->number);
	read_socket_int(server_socket, (int *)&(*entry)->date);
	read_socket_int(server_socket, (int *)&(*entry)->lines);
	read_socket(server_socket, (*entry)->poster, sizeof((*entry)->poster));
	read_socket(server_socket, (*entry)->id, sizeof((*entry)->id));
	read_socket(server_socket, (*entry)->nick, sizeof((*entry)->nick));
	read_socket(server_socket, (*entry)->subject,
		    sizeof((*entry)->subject));
	read_socket_int(server_socket, (int *)&(*entry)->expiration);
	entry++;
	if (!read_server_code(&code)) {
	    unblock();
	    return NULL;
	}
    }
    unblock();
    if (code != SERVER_EOF)
	return NULL;
    result.count = i;
    result.list = (void **)list;
    return &result;
}
