#include "../rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/lib/client/users.c,v 1.5 1999/08/07 00:26:06 kc Exp $")

#include <stdlib.h> // For malloc, qsort
#include "header.h"

static int user_order(const void *, const void *);

result_list *client_users()
{
    static result_list result;
    static user_list_info *list[MAX_CLIENTS];
    user_list_info **entry;
    int code;

    block();
    write_server_code(CLIENT_USERS);
    if (!read_server_code(&code)) {
	unblock();
	return NULL;
    }
    result.count = 0;
    result.list = (void **)list;
    entry = list;
    while (code == SERVER_ACK) {
	if (!*entry)
	    *entry = (user_list_info *)malloc(sizeof(user_list_info));
	read_socket(server_socket, (*entry)->address,
		    sizeof((*entry)->address));
	read_socket(server_socket, (*entry)->nick, sizeof((*entry)->nick));
	read_socket(server_socket, (*entry)->id, sizeof((*entry)->id));
	read_socket(server_socket, (*entry)->room, sizeof((*entry)->room));
	read_socket_int(server_socket, (int *)&(*entry)->idle);
	read_socket_int(server_socket, &(*entry)->slot);
	if (server_minor >= 2) {
	    read_socket_int(server_socket, &(*entry)->major_version);
	    read_socket_int(server_socket, &(*entry)->minor_version);
	}
	result.count++;
	entry++;
	if (!read_server_code(&code)) {
	    unblock();
	    return NULL;
	}
    }
    unblock();
    if (code != SERVER_EOF)
	return NULL;
    qsort(list, result.count, sizeof(user_list_info *), user_order);
    return &result;
}

static int user_order(const void *p1, const void *p2)
{
    const user_list_info * const *ui1 = p1;
    const user_list_info * const *ui2 = p2;

    return istrcmp((*ui1)->id, (*ui2)->id);
}
