#include "rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/lib/misc.c,v 1.4 1999/08/07 00:25:52 kc Exp $")

#include <ctype.h>
#ifndef VMS
#include <strings.h>
#include <stdlib.h>
#else
#include <string.h>
#endif VMS

#include "misc.h"

char *downcase(char *s_out, const char *s_in)
{
    char               *s;

    for (s = s_out; *s_in; s++, s_in++)
	if (isupper(*s_in)) {
	    *s = tolower(*s_in);
	} else {
	    *s = *s_in;
	}
    *s = 0;
    return s_out;
}

int istrcmp(const char *s1, const char *s2)
{
    char                c1, c2;

    for (; *s1 && *s2; s1++, s2++) {
	if (isupper(c1 = (*s1)))
	    c1 = tolower(*s1);
	if (isupper(c2 = (*s2)))
	    c2 = tolower(*s2);
	if (c1 != c2)
	    return (c1 - c2);
    }
    return (*s1) - (*s2);
}

int istrncmp(const char *s1, const char *s2, int n)
{
    char                c1, c2;
    int                 c;

    for (c = 0; c < n && *s1 && *s2; s1++, s2++, c++) {
	if (isupper(c1 = (*s1)))
	    c1 = tolower(*s1);
	if (isupper(c2 = (*s2)))
	    c2 = tolower(*s2);
	if (c1 != c2)
	    return (c1 - c2);
    }
    return c < n ? (*s1) - (*s2) : 0;
}

#ifdef VMS
#include <stdio.h>

char *optarg;
int optind, opterr;

int getopt (argc, argv, optstring)
     int argc;
     char **argv, *optstring;
{
    return EOF;
}


FILE *popen(command, type)
     char *command, *type;
{
    return (FILE *)0;
}


pclose(stream)
     FILE *stream;
{
    return -1;
}

#endif VMS

#ifndef VMS
#include <pwd.h>
#endif VMS
#define BUFFER_SIZE (512)

/* tilde.c
 *
 * Evaluate ~ filename expressions, including ~ and ~username
 * It returns 0 if the original expression does not begin with ~.
 * (Is there any use for having ~'s other than as the first character?)
 *
 * Jon "~root/setuid" Sari, 1990
 *
 * Ken Case, 1991	modified to return original string on failure,
 *			rather than NULL, and to get the passwd entry
 *			itself.
 */

const char *tilde(const char *file)
{
    static struct passwd *user = (struct passwd *) 0;
    const char         *ptr, *orig = file;
    static char         buf[BUFFER_SIZE];

    if (!file || *file != '~')
	return orig;

 /* Evaluate ~ expressions. */
    if (*++file == '/')		/* Increment past '~' */
	strncpy(buf, (char *)getenv("HOME"), BUFFER_SIZE);
    else {
	int                 i;

	ptr = file;
	if (!(file = (char *)index(file, '/')))
	    return orig;
#ifdef VMS
	for (buf[0] = '[', i = 1; ptr < file; buf[i++] = *ptr++);
	buf[i++] = ']';
	buf[i] = '\0';
	file++;
#else
	for (i = 0; ptr < file; buf[i++] = *ptr++);
	buf[i] = '\0';
	if (user && strcmp(buf, user->pw_name) == 0)
	    strncpy(buf, user->pw_dir, BUFFER_SIZE);
	else {
	/* Find out who it might be */
	    if (!(user = getpwnam(buf))) {
		return orig;
	    } else {
		strncpy(buf, user->pw_dir, BUFFER_SIZE);
	    }
	}
#endif VMS
    }
    strncat(buf, file, BUFFER_SIZE - strlen(buf));
    return buf;
}


#ifdef XA370
#include <signal.h>

signal_t (*signal (int sig, signal_t (*action)()))()
{
    struct sigaction   *act, oact, act_template;

    act = &act_template;
    act->sa_handler = (__SIGVOID(*) ()) action;
    sigemptyset(&act->sa_mask);
    act->sa_flags = SA_RESTART;
    if (sigaction(sig, act, &oact) == -1)
	return (signal_t (*) ())-1;
    return (signal_t (*) ())oact.sa_handler;
}

#endif XA370
