#include <sys/types.h>
#include <regex.h>

static int haveCompiledExpression = 0;
static regex_t compiledExpression;

char *re_comp(const char *pattern)
{
    int returnValue;

    returnValue = regcomp(&compiledExpression, pattern, REG_EXTENDED | REG_NOSUB | REG_NEWLINE);
    switch (returnValue) {
	case 0:
	    haveCompiledExpression = 1;
	    return (void *)0;
	case REG_BADPAT:
	default:
	    return "invalid regular expression";
    }
}

int re_exec(const char *string)
{
    int returnValue;

    if (!haveCompiledExpression)
	return -1;
    returnValue = regexec(&compiledExpression, string, 0, (void *)0, 0);
    switch (returnValue) {
	case 0:
	    return 1;
	case REG_NOMATCH:
	    return 0;
	default:
	    return -1;
    }
}
