#include "convertlib.h"

int Convert = 1;

long int do_flipl(long i)
{
  union {
    char bytes[4];
    long value;
  } x, y;

  if(!Convert) return i;
  y.value = i;
  x.bytes[0] = y.bytes[3];
  x.bytes[1] = y.bytes[2];
  x.bytes[2] = y.bytes[1];
  x.bytes[3] = y.bytes[0];
  return x.value;
}

void convert_gid(bb_gid *x)
{
  if(!Convert) return;
  flipl(*x);
}

void convert_rid(bb_rid *x)
{
  if(!Convert) return;
  flipl(*x);
}

void convert_uid(bb_uid *x)
{
  if(!Convert) return;
  flipl(*x);
}

void convert_user_entry(user_entry *x)
{
  int i;

  if(!Convert) return;
  flipl(x->last_access_time);
  flipl(x->uses);
  flipl(x->posts);
  flipl(x->connect_time);
  flipl(x->cutoff_priority);
  for(i = 0; i < MAX_GROUPS; i++) {
    flipl(x->group_priority[i]);
    flipl(x->group_class[i]);
  }
}

void convert_directory_entry(directory_entry *x)
{
  int i;

  if(!Convert) return;
  flipl(x->owner_uid);
  flipl(x->creation_time);
  flipl(x->default_expiration);
  flipl(x->default_class);
  flipl(x->next_message_number);
  flipl(x->first_message_number);
  flipl(x->room_offset);
  for(i=0; i < howmany(MAX_GROUPS, NGROUPBITS); i++)
    flipl(x->groups.group_bits[i]);
}

void convert_room_user_entry(room_user_entry *x)
{
  if(!Convert) return;
  flipl(x->last_message_read);
  flipl(x->user_offset);
  flipl(x->class);
}

void convert_group_entry(group_entry *x)
{
  if(!Convert) return;
  flipl(x->owner);
  flipl(x->default_class);
  flipl(x->group_offset);
  flipl(x->max_expiration);
}

void convert_summary_list(summary_list *summary)
{
  summary_entry *entry;
  message_entry *message_info;

  if(!Convert) return;
  flipl(summary->count);
  for(entry = summary->list;
      entry < summary->list + summary->count;
      entry++) {
    flipl(entry->number);
    message_info = &(entry->header);
    flipl(message_info->date);
    flipl(message_info->expiration);
    flipl(message_info->size);
    flipl(message_info->lines);
    flipl(message_info->poster_uid);
  }
}

