#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/misc/dumpdbm.c,v 1.3 2000/01/30 06:11:17 kc Exp $")

#include <ndbm.h>
#include <stdio.h>
#include <fcntl.h>

void writedatum(datum someDatum);
void usage(const char *name);
void writedata(const void *ptr, size_t size);
void writestring(const char *string);

int main(int argc, char *argv[])
{
    DBM *db;
    datum key;

    if (argc != 2) {
        usage(argv[0]);
    }
    db = dbm_open(argv[1], O_RDONLY, 0666);
    for (key = dbm_firstkey(db); key.dptr != NULL; key = dbm_nextkey(db)) {
	datum content;

	content = dbm_fetch(db, key);
	if (content.dptr == NULL) {
	    perror("dbm_fetch");
	    exit(1);
	}
	writestring("key = ");
	writedatum(key);
	writestring("content = ");
	writedatum(content);
    }
    dbm_close(db);
    return 0;
}

void writedatum(datum someDatum)
{
    writestring("size = ");
    writedata(&someDatum.dsize, sizeof(someDatum.dsize));
    writestring(", value = ");
    writedata(someDatum.dptr, someDatum.dsize);
    writestring("\n");
}

void writedata(const void *ptr, size_t size)
{
    if (fwrite(ptr, size, 1, stdout) != 1) {
	perror("fwrite");
	exit(1);
    }
}

void writestring(const char *string)
{
    // writedata(string, strlen(string));
}

void usage(const char *name)
{
    fprintf(stderr, "usage: %s dbname\n", name);
    exit(1);
}
