#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/misc/findroom.c,v 1.1 2000/03/28 17:50:42 kc Exp $")

#include <ndbm.h>
#include <stdio.h>
#include <fcntl.h>
#include <string.h> // For bcopy()

void writedatum(datum someDatum);
void usage(const char *name);
void writedata(const void *ptr, size_t size);
void writestring(const char *string);

int main(int argc, char *argv[])
{
    DBM *db;
    datum key;
    int roomId;

    if (argc != 2) {
        usage(argv[0]);
    }
    db = dbm_open(argv[1], O_RDONLY, 0666);
    for (key = dbm_firstkey(db); key.dptr != NULL; key = dbm_nextkey(db)) {
	datum content;

        if (key.dptr[0] != 'r')
            continue;
	content = dbm_fetch(db, key);
	if (content.dptr == NULL) {
	    perror("dbm_fetch");
	    exit(1);
	}
	if (content.dsize != sizeof(roomId)) {
	    fprintf(stderr, "Warning: content size != sizeof(roomId)\n");
            continue;
        }
        bcopy(content.dptr, &roomId, sizeof(roomId));
        printf("%4d %s\n", roomId, key.dptr + 1);
    }
    dbm_close(db);
    return 0;
}

void writedatum(datum someDatum)
{
    writestring("size = ");
    writedata(&someDatum.dsize, sizeof(someDatum.dsize));
    writestring(", value = ");
    writedata(someDatum.dptr, someDatum.dsize);
    writestring("\n");
}

void writedata(const void *ptr, size_t size)
{
    if (fwrite(ptr, size, 1, stdout) != 1) {
	perror("fwrite");
	exit(1);
    }
}

void writestring(const char *string)
{
    writedata(string, strlen(string));
}

void usage(const char *name)
{
    fprintf(stderr, "usage: %s dbname\n", name);
    exit(1);
}
