#include "../server/server.h"

char *classes[] =
{"no_access", "read_only", "read_write", "moderator", "no_class"};

main(int argc, char *argv[])
{
    group_entry group_info;
    bb_gid gid;

    chdir(MESSAGEBASE);
    database_init(TRUE, FALSE);
    gid = get_gid(argv[1]);
    if (!get_group_entry(&group_info, gid)) {
	fprintf(stderr, "%s: no such group\n", argv[1]);
	return 1;
    }
    printf("group: %s (%d)\n", group_info.name, gid);
    printf("owner: <%s> (%d)\n", get_id(group_info.owner), group_info.owner);
    printf("default class: %s\n", classes[group_info.default_class]);
    printf("max expiration: %d day%s\n",
	   group_info.max_expiration /= 86400,
	   group_info.max_expiration == 1 ? "" : "s");
    printf("group offset: %d\n", group_info.group_offset);
    database_shutdown();
    return 0;
}
