#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/misc/load.c,v 1.3 1999/08/07 00:22:07 kc Exp $")

#include <stdio.h>
#include "../server/config.h"
#include "../server/database.h"
#include "convertlib.h"

int main(int argc, char *argv[])
{
    char message_base[80] = "";
    int ch;
    extern char *optarg;
    static bb_rid rid;
    bb_uid uid;
    bb_gid gid;
    directory_entry room_info;
    user_entry user_info;
    group_entry group_info;
    room_user_entry room_user_info;
    summary_list *summary;
    int test;

    while ((ch = getopt(argc, argv, "M:")) != EOF)
	switch (ch) {
	case 'M':
	    strcpy(message_base, optarg);
	    break;
	}
    if (!*message_base) {
	fprintf(stderr, "usage: %s -M messagebase [-t]\n", argv[0]);
	return 1;
    }
    if (chdir(message_base) != 0) {
	perror(message_base);
	return 1;
    }
    if (!database_init(FALSE, FALSE)) {
	perror("database init failed");
	return 1;
    }
    fread((char *)&test, sizeof(test), 1, stdin);
    if(Convert = (test != 0x01020304)) flipl(test);
    if(test != 0x01020304) {
	fprintf(stderr, "unrecognized format\n");
	return 1;
    }
    fread((char *)&gid, sizeof(gid), 1, stdin);
    convert_gid(&gid);
    fread((char *)&rid, sizeof(rid), 1, stdin);
    convert_rid(&rid);
    fread((char *)&uid, sizeof(uid), 1, stdin);
    convert_uid(&uid);
    database_changelast(gid, rid, uid);
    printf("Loading %d groups. . .\n", (int)Last_gid);
    fflush(stdout);
    do {
	fread((char *)&gid, sizeof(gid), 1, stdin);
	convert_gid(&gid);
	if (gid == -1)
	    break;
	fread((char *)&group_info, sizeof(group_info), 1, stdin);
	convert_group_entry(&group_info);
	if (!put_gid(gid, group_info.name))
	    perror("put_gid");
	if (!put_group_entry(gid, &group_info))
	    perror("put_group_entry");
    } while (1);
    printf("Loading %d rooms. . .\n", (int)Last_rid);
    fflush(stdout);
    do {
	fread((char *)&rid, sizeof(rid), 1, stdin);
	convert_rid(&rid);
	if (rid == -1)
	    break;
	fread((char *)&room_info, sizeof(room_info), 1, stdin);
	convert_directory_entry(&room_info);
	if (!put_rid(rid, room_info.name))
	    perror("put_rid");
	if (!put_directory_entry(rid, &room_info))
	    perror("put_directory_entry");
    } while (1);
    printf("Loading %d users. . .\n", (int)Last_uid);
    fflush(stdout);
    do {
	fread((char *)&uid, sizeof(uid), 1, stdin);
	convert_uid(&uid);
	if (uid == -1)
	    break;
	fread((char *)&user_info, sizeof(user_info), 1, stdin);
	convert_user_entry(&user_info);
	if (!put_uid(uid, user_info.id))
	    perror("put_uid");
	if (!put_user_entry(uid, &user_info))
	    perror("put_user_entry");
    } while (1);
    printf("Loading summaries. . .\n");
    fflush(stdout);
    do {
	int i;

	fread((char *)&rid, sizeof(rid), 1, stdin);
	convert_rid(&rid);
	if (rid == -1)
	    break;
	printf("%4d ", (int)rid);
	fflush(stdout);
	if (!(summary = get_summary(rid))) {
	    perror("get_summary");
	    return 1;
	}
	fread((char *)&summary->count, sizeof(summary->count), 1, stdin);
	flipl(summary->count);
	summary->list = (summary_entry *)
	  malloc(summary->count * sizeof(summary_entry));
	for (i = 0; i < summary->count; i++) {
	    fread((char *)&summary->list[i].number,
		  sizeof(summary->list[i].number),
		  1,
		  stdin);
	    fread((char *)&summary->list[i].header.date,
		  sizeof(summary->list[i].header.date),
		  1,
		  stdin);
	    fread((char *)&summary->list[i].header.expiration,
		  sizeof(summary->list[i].header.expiration),
		  1,
		  stdin);
	    fread((char *)&summary->list[i].header.size,
		  sizeof(summary->list[i].header.size),
		  1,
		  stdin);
	    fread((char *)&summary->list[i].header.lines,
		  sizeof(summary->list[i].header.lines),
		  1,
		  stdin);
	    fread((char *)&summary->list[i].header.deleted,
		  sizeof(summary->list[i].header.deleted),
		  1,
		  stdin);
	    fread((char *)&summary->list[i].header.poster_uid,
		  sizeof(summary->list[i].header.poster_uid),
		  1,
		  stdin);
	    fread(summary->list[i].header.poster_nick,
		  sizeof(summary->list[i].header.poster_nick),
		  1,
		  stdin);
	    fread(summary->list[i].header.poster_id,
		  sizeof(summary->list[i].header.poster_id),
		  1,
		  stdin);
	    fread(summary->list[i].header.subject,
		  sizeof(summary->list[i].header.subject),
		  1,
		  stdin);
	}
	flipl(summary->count);
	convert_summary_list(summary);
	summary->version++;
    } while (1);
    printf("done!\n");
    fflush(stdout);
    dump_cache();
    printf("Loading user pointers. . .\n");
    fflush(stdout);
    do {
	fread((char *)&uid, sizeof(uid), 1, stdin);
	convert_uid(&uid);
	if (uid == -1)
	    break;
	printf("%4d ", (int)uid);
	fflush(stdout);
	do {
	    fread((char *)&rid, sizeof(rid), 1, stdin);
	    convert_rid(&rid);
	    if (rid == -1)
		break;
	    fread((char *)&room_user_info, sizeof(room_user_info), 1, stdin);
	    convert_room_user_entry(&room_user_info);
	    if (!put_room_user_entry(rid, uid, &room_user_info))
		continue;
	} while (1);
    } while (1);
    printf("done!\n");
    database_shutdown();
    return 0;
}
