#include "../server/server.h"

int CurrentMessage = 0, Lastmessage = 0;
char Roomname[BUFFER_SIZE] = "";

void display_message(char *roomname, bb_rid room_id, int messagenumber);

int main(int argc, char *argv[])
{
    char *roomname;
    bb_rid room_id;
    int messagenumber;

    argc--;
    argv++;
    if (chdir(MESSAGEBASE) == -1) {
	perror("accessing messagebase");
	return 1;
    }
    database_init(TRUE, FALSE);
    switch (argc) {
    default:
	roomname = argv[0];
	break;
    case 0:
	fprintf(stderr, "format: read <room> [<messagenumber>]\n");
	return 1;
    }
    room_id = get_rid(roomname);
    if (room_id == -1) {
	if (sscanf(roomname, "%d", (int *)&room_id) != 1) {
	    fprintf(stderr, "No such room '%s'\n", roomname);
	    return -1;
	}
    }
    strcpy(Roomname, roomname);
    if (argc > 1) {
	int i;

	for (i = 1; i < argc; i++) {
	    sscanf(argv[i], "%d", &messagenumber);
	    display_message(roomname, room_id, messagenumber);
	}
    } else {
	directory_entry room_info;

	if (get_directory_entry(&room_info, room_id)) {
	    for (messagenumber = room_info.first_message_number;
		 messagenumber <= room_info.next_message_number - 1;
		 messagenumber++)
		display_message(roomname, room_id, messagenumber);
	} else {
	    fprintf(stderr, "No such room %s\n", roomname);
	}
    }
    return 0;
}

#include "../bb/config.h"
char *format_message_header(header_info header, char *format);

void display_message(char *roomname, bb_rid room_id, int messagenumber)
{
    message_entry message_info;
    header_info header;
    char message_file[BUFFER_SIZE];
    FILE *file;
    char buf[BUFFER_SIZE];

    if (!db_get_message_entry(&message_info, room_id, messagenumber)) {
	fprintf(stderr, "No such message %s #%d\n", roomname, messagenumber);
	return;
    }
    header.number = messagenumber;
    header.date = message_info.date;
    header.expiration = message_info.expiration;
    header.lines = message_info.lines;
    strcpy(header.poster, message_info.poster_id);
    strcpy(header.id, get_id(message_info.poster_uid));
    strcpy(header.nick, message_info.poster_nick);
    strcpy(header.subject, message_info.subject);
    fputs(format_message_header(header, HEADER_FORMAT), stdout);
    sprintf(message_file, ACTIVE_MESSAGE, (int)room_id, messagenumber);
    if (file = fopen(message_file, "r")) {
	while (fgets(buf, sizeof(buf), file))
	    fputs(buf, stdout);
	fclose(file);
	fputs("\n", stdout);
    }
}
