#include "../server/server.h"

char *classes[] =
{"no_access", "read_only", "read_write", "moderator", "no_class"};
char *archives[] =
{"common", "mail", "none"};

main(int argc, char *argv[])
{
    directory_entry room_info;
    bb_rid rid;

    chdir(MESSAGEBASE);
    database_init(TRUE, FALSE);
    rid = get_rid(argv[1]);
    if (rid == -1 && sscanf(argv[1], "%d", &rid) != 1) {
	fprintf(stderr, "%s: no such room\n", argv[1]);
	return 1;
    }
    if (!get_directory_entry(&room_info, rid)) {
	fprintf(stderr, "error getting directory entry for %d\n", rid);
	return 1;
    }
    printf("room: %s (%d)\n", room_info.name, rid);
    printf("owner: <%s> (%d)\n",
	   get_id(room_info.owner_uid), room_info.owner_uid);
    printf("creation time: %s", ctime(&room_info.creation_time));
    printf("default expiration: %d day%s\n",
	   room_info.default_expiration /= 86400,
	   room_info.default_expiration == 1 ? "" : "s");
    printf("default class: %s\n", classes[room_info.default_class]);
    printf("first message number: %d\n", room_info.first_message_number);
    printf("next message number: %d\n", room_info.next_message_number);
    printf("summary: %s\n", room_info.summary_line);
    printf("groups: 0x%04x\n", room_info.groups);
    printf("room offset: %d\n", room_info.room_offset);
    printf("archive: %s\n", archives[room_info.archive]);
    database_shutdown();
    return 0;
}
