#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/misc/unload.c,v 1.3 1999/08/07 00:22:07 kc Exp $")

#include <stdio.h>
#include "../server/config.h"
#include "../server/database.h"

int main(int argc, char *argv[])
{
    char message_base[80] = MESSAGEBASE;
    int ch;
    extern char *optarg;
    static bb_rid rid;
    bb_uid uid;
    bb_gid gid;
    directory_entry room_info;
    user_entry user_info;
    group_entry group_info;
    room_user_entry room_user_info;
    summary_list *summary;
    boolean *room_exists, *user_exists;
    int test;

    while ((ch = getopt(argc, argv, "M:")) != EOF)
	switch (ch) {
	case 'M':
	    strcpy(message_base, optarg);
	    break;
	}
    if (chdir(message_base) != 0) {
	perror(message_base);
	return 1;
    }
    if (!database_init(TRUE, FALSE)) {
	perror("database init failed");
	return 1;
    }
    test = 0x01020304;
    fwrite((char *)&test, sizeof(test), 1, stdout);
    fwrite((char *)&Last_gid, sizeof(Last_gid), 1, stdout);
    fwrite((char *)&Last_rid, sizeof(Last_rid), 1, stdout);
    fwrite((char *)&Last_uid, sizeof(Last_uid), 1, stdout);
    fprintf(stderr, "Unloading %d groups. . .\n", Last_gid);
    fflush(stderr);
    for (gid = 0; gid <= Last_gid; gid++) {
	if (!get_group_entry(&group_info, gid))
	    continue;
	fwrite((char *)&gid, sizeof(gid), 1, stdout);
	fwrite((char *)&group_info, sizeof(group_info), 1, stdout);
    }
    gid = -1;
    fwrite((char *)&gid, sizeof(gid), 1, stdout);
    fprintf(stderr, "Unloading %d rooms. . .\n", Last_rid);
    fflush(stderr);
    room_exists = (boolean *) malloc((Last_rid + 1) * sizeof(boolean));
    bzero((char *)room_exists, (Last_rid + 1) * sizeof(boolean));
    for (rid = 0; rid <= Last_rid; rid++) {
	if (!get_directory_entry(&room_info, rid))
	    continue;
	room_exists[rid] = TRUE;
	fwrite((char *)&rid, sizeof(rid), 1, stdout);
	fwrite((char *)&room_info, sizeof(room_info), 1, stdout);
    }
    rid = -1;
    fwrite((char *)&rid, sizeof(rid), 1, stdout);
    fprintf(stderr, "Unloading %d users. . .\n", Last_uid);
    fflush(stderr);
    user_exists = (boolean *) malloc((Last_uid + 1) * sizeof(boolean));
    bzero((char *)user_exists, (Last_rid + 1) * sizeof(boolean));
    for (uid = 0; uid <= Last_uid; uid++) {
	if (!get_user_entry(&user_info, uid))
	    continue;
	user_exists[uid] = TRUE;
	fwrite((char *)&uid, sizeof(uid), 1, stdout);
	fwrite((char *)&user_info, sizeof(user_info), 1, stdout);
    }
    uid = -1;
    fwrite((char *)&uid, sizeof(uid), 1, stdout);
    fprintf(stderr, "Unloading summaries. . .\n");
    fflush(stderr);
    for (rid = 0; rid <= Last_rid; rid++) {
	int i;

	if (!room_exists[rid])
	    continue;
	if (!(summary = get_summary(rid)))
	    continue;
	if (!summary->count)
	    continue;
	fprintf(stderr, "%4d ", rid);
	fflush(stderr);
	fwrite((char *)&rid, sizeof(rid), 1, stdout);
	fwrite((char *)&summary->count, sizeof(summary->count), 1, stdout);
	for (i = 0; i < summary->count; i++) {
	    fwrite((char *)&summary->list[i].number,
		   sizeof(summary->list[i].number),
		   1,
		   stdout);
	    fwrite((char *)&summary->list[i].header.date,
		   sizeof(summary->list[i].header.date),
		   1,
		   stdout);
	    fwrite((char *)&summary->list[i].header.expiration,
		   sizeof(summary->list[i].header.expiration),
		   1,
		   stdout);
	    fwrite((char *)&summary->list[i].header.size,
		   sizeof(summary->list[i].header.size),
		   1,
		   stdout);
	    fwrite((char *)&summary->list[i].header.lines,
		   sizeof(summary->list[i].header.lines),
		   1,
		   stdout);
	    fwrite((char *)&summary->list[i].header.deleted,
		   sizeof(summary->list[i].header.deleted),
		   1,
		   stdout);
	    fwrite((char *)&summary->list[i].header.poster_uid,
		   sizeof(summary->list[i].header.poster_uid),
		   1,
		   stdout);
	    fwrite(summary->list[i].header.poster_nick,
		   sizeof(summary->list[i].header.poster_nick),
		   1,
		   stdout);
	    fwrite(summary->list[i].header.poster_id,
		   sizeof(summary->list[i].header.poster_id),
		   1,
		   stdout);
	    fwrite(summary->list[i].header.subject,
		   sizeof(summary->list[i].header.subject),
		   1,
		   stdout);
	}
    }
    rid = -1;
    fwrite((char *)&rid, sizeof(rid), 1, stdout);
    fprintf(stderr, "done!\n");
    fflush(stderr);
    fprintf(stderr, "Unloading user pointers. . .\n");
    fflush(stderr);
    for (uid = 0; uid <= Last_uid; uid++) {
	if (!user_exists[uid])
	    continue;
	fprintf(stderr, "%4d ", uid);
	fflush(stderr);
	fwrite((char *)&uid, sizeof(uid), 1, stdout);
	for (rid = 0; rid <= Last_rid; rid++) {
	    if (!room_exists[rid])
		continue;
	    if (!get_room_user_entry(&room_user_info, rid, uid))
		continue;
	    fwrite((char *)&rid, sizeof(rid), 1, stdout);
	    fwrite((char *)&room_user_info, sizeof(room_user_info), 1, stdout);
	}
	rid = -1;
	fwrite((char *)&rid, sizeof(rid), 1, stdout);
    }
    uid = -1;
    fwrite((char *)&uid, sizeof(uid), 1, stdout);
    fprintf(stderr, "done!\n");
    database_shutdown();
    return 0;
}
