#include "../server/config.h"
#include "../server/server.h"
#include <ndbm.h>

int max_active_slot;
struct client_struct client[MAX_CLIENTS];

extern DBM *directory;

main(argc,argv)
     int argc;
     char *argv[];
{
  char *id;
  user_entry *user_info;

  if(argc!=2) {
    printf("usage: %s <id>\n",argv[0]);
    return;
  }
  chdir(MESSAGEBASE);
  database_init();
  id = argv[1];
  user_info = get_user_entry(id);
  if(!user_info) {
    printf("no such user %s\n",id);
  } else {
    char room[ROOM_SIZE];
    datum key;
    int room_count = 0;

    for (key = dbm_firstkey(directory);
	 key.dptr != NULL;
	 key = dbm_nextkey(directory)) {
      bzero(room,sizeof(room));
      bcopy(key.dptr,room,key.dsize);
      if(get_room_user_entry(room,id)) room_count++;
    }
    printf("user %s has entries in %d rooms: %s",
	   id,
	   room_count,
	   ctime(&(user_info->last_access_time)));
  }
  database_shutdown();
}
