#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/changeclass.c,v 1.4 1999/03/14 23:14:27 kc Exp $")

#include "server.h"

void server_changeclass(int i)
{
  char id[ID_SIZE];
  class_t class;
  DbRoomUser db_room_user;
  DbUser db_user;
  bb_uid uid;
  DbDirectory *db_dir;

  read_socket_s(Client[i].socket, id, sizeof(id));
  read_socket_int(Client[i].socket, (int *) &class);
  if(Client[i].rid == -1)
    SERVER_ERROR("no room selected");
  if(!MODERATOR_ACCESS(get_class(i, Client[i].rid)) &&
     !Client[i].owner)
    SERVER_ERROR("permission denied");
  uid = get_uid(id);
  if(!get_db_user(&db_user, uid))
    SERVER_ERROR("no such user");
  if(!get_db_room_user(&db_room_user, Client[i].rid, uid)) {
    db_room_user.last_message_read = 0;
    db_room_user.user_offset = DEFAULT_USER_OFFSET;
  }
  db_room_user.class = class;
  if(!put_db_room_user(Client[i].rid, uid, &db_room_user)) 
    SERVER_ERROR("error storing user information");
  if(class == no_class && !DAEMON(uid)) {
    if(!(db_dir = get_db_room_directory(Client[i].rid)))
      SERVER_ERROR("error accessing room information");
    class = db_dir->default_class;
  }
  write_socket_code(Client[i].socket, SERVER_ACK);
}
