#ifdef OMNI

#define USER_UID        (105)   /* The Unix uid of the bb account */
#define OWNER_UID	(0)	/* bb */
#define DAEMON_UID	(5)	/* daemon */

#define CHANGECLASSLOGFILE	"log"

#elif WIZARDS

#warning define USER_ID to the bb unix account uid
#define OWNER_UID	(5)	/* bb */
#define DAEMON_UID	(36)	/* daemon */

#else
#warning define USER_ID to the bb unix account uid
#warning define OWNER_UID and DAEMON_UID in server config.h file

#endif

#define MESSAGEBASE	"/usr/local/lib/bb"

#define OPERATOR(uid)	(OWNER(uid) || (uid) == 1)
#define OWNER(uid)	((uid) == Owner_uid)
#define DAEMON(uid)	((uid) == Daemon_uid)

#define TIMEOUT			(3600)		/* 1 hour */
#define CACHE_TIMEOUT		(600)		/* 10 minutes */
#define DEFAULT_EXPIRATION	(30*86400)	/* 30 days */
#define MIN_EXPIRATION		(600)		/* 10 minutes */
#define MAX_EXPIRATION		(45*86400)	/* 45 days */
#define MAX_PRESERVATION	(10*365*86400)	/* 10 years */
#define USER_EXPIRATION_PERIOD	(183*86400)	/* 6 months */

#define DEFAULT_CUTOFF_PRIORITY	(0)
#define SYSTEM_CUTOFF		(-1000000000)
#define DEFAULT_USER_OFFSET	(SYSTEM_CUTOFF-1)
#define DEFAULT_ROOM_OFFSET	(0)
#define DEFAULT_GROUP_OFFSET	(-1000)

#define DEFAULT_ROOM_CLASS	(read_write)
#define DEFAULT_GROUP_CLASS	(read_only)
#define DEFAULT_GROUP		(0)

#define ACTIVE_ROOM "active/%04d"
	/* sprintf(filename, ACTIVE_ROOM, room_arid) */
#define ACTIVE_MESSAGE "active/%04d/%06d"
	/* sprintf(filename, ACTIVE_MESSAGE, room_arid, messagenumber) */
#define EXPIRED_BASE "expired"
#define EXPIRED_ROOM "expired/%04d"
        /* sprintf(filename, EXPIRED_ROOM, <absolute rid>) */
#define EXPIRED_MESSAGE "expired/%04d/post%06d"
	/* sprintf(filename, EXPIRED_MESSAGE, room_arid, messagenumber) */
#define STARTUP_USERS "dbm/startup.users"
#define STARTUP_ROOMS "dbm/startup.rooms"
#define EXPIRED_ROOMS "expired/Rooms"

#define OLD_DIRECTORY   "dbm/directory"
#define DIRECTORY	"dbm/directory.new"
#define USER		"dbm/user"
#define ROOM		"dbm/room"
#define OLD_SUMMARY     "dbm/summary"
#define SUMMARY         "dbm/summary.new"
#define LOGFILE		"log"
#define PIDFILE		"pid"
