#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/create.c,v 1.5 2001/05/11 00:48:00 kc Exp $")

#include "server.h"

void server_create(int i)
{
    char room[ROOM_SIZE], summary[LINE_SIZE];
    bb_rid rid;
    char directory[LINE_SIZE];
    DbDirectory *db_directory; /* alias */

    /* save pointer of previous room */
    save_room_pointer(i);
    read_socket_s(Client[i].socket, room, sizeof(room));
    read_socket_s(Client[i].socket, summary, sizeof(summary));
    if (DAEMON(Client[i].uid))
	SERVER_ERROR("permission denied");
    if (get_rid(room) != -1)
	SERVER_ERROR("room already exists");

    /* create and intialize room, room data */
    rid = add_db_room(room);
    if (!(db_directory = get_db_room_directory(rid))) {
      remove_db_room(rid);
      SERVER_ERROR("directory error creating room");
    }

    sprintf(directory, ACTIVE_ROOM, (int)db_directory->arid);
    if (mkdir(directory, 0777) < 0 ) {
      rmdir(directory);
      syslog(LOG_ERR, "mkdir (%s) failed: %m\n", directory);
      SERVER_ERROR("filesystem error creating room");
    }
      
    GROUP_ZERO(&db_directory->groups);
    GROUP_SET(DEFAULT_GROUP, &db_directory->groups);
    db_directory->default_expiration = expiration_limit(db_directory->groups);
    if (db_directory->default_expiration > DEFAULT_EXPIRATION)
	db_directory->default_expiration = DEFAULT_EXPIRATION;
    db_directory->default_class = DEFAULT_ROOM_CLASS;
    db_directory->owner_uid = Client[i].uid;
    db_directory->room_offset = DEFAULT_ROOM_OFFSET;
    bcopy(summary, db_directory->summary_line, sizeof(summary));
    db_directory->archive = common_archive;
    
    write_socket_code(Client[i].socket, SERVER_ACK);
    /* instead of put_directory_entry --dmy */
    update_cached_room_user_info(rid, -1);
    /* move to new room */
    Client[i].rid = rid;
    Client[i].last_message_read = 0;
    {
      FILE *dump_f;
      char temp_buf1[32], temp_buf2[32];

      if ((dump_f = fopen(STARTUP_ROOMS, "a"))) {
	sprintf(temp_buf1, "[%d]", (int)db_directory->arid);
	sprintf(temp_buf2, "(%s)", db_directory->name);
	fprintf(dump_f, "%4d %6s %-22s %4d (%s) (NEW)\n",
		(int)rid, temp_buf1, temp_buf2, (int)db_directory->owner_uid,
		get_id(db_directory->owner_uid));
      }
      fclose(dump_f);
    }
	
}
