#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/directory.c,v 1.4 1999/03/14 23:14:30 kc Exp $")

#include "server.h"

void server_directory(int i)
{
    directory_info *dir_info;
    bb_rid rid;
    int update;

    if (Client[i].update_directory >= Directory_stamp) {
	write_socket_code(Client[i].socket, SERVER_NAK);
	return;
    }
    for (rid = 0; rid <= Last_rid; rid++) {
	if (Client[i].minor_version >= 3) {
	    update = Client[i].stamp[rid].update > Client[i].stamp[rid].sent;
	}
	if (!(dir_info = get_dir_info(i, rid)) ||
	    (!Client[i].owner &&
	     (NO_ACCESS(dir_info->class) ||
	      dir_info->priority <= SYSTEM_CUTOFF))) {
	    if (Client[i].minor_version >= 3) {
		if (Client[i].stamp[rid].sent < Client[i].stamp[rid].update) {
		    if (Client[i].stamp[rid].sent) {
			write_socket_code(Client[i].socket,
					  SERVER_DELETE_ROOM);
			write_socket_int(Client[i].socket, rid);
		    }
		    Client[i].stamp[rid].sent = Client[i].stamp[rid].update;
		}
	    }
	} else {
	    if (Client[i].minor_version >= 3) {
		if (Client[i].stamp[rid].sent >= Client[i].stamp[rid].update)
		    continue;
		Client[i].stamp[rid].sent = Client[i].stamp[rid].update;
	    }
	    write_socket_code(Client[i].socket, SERVER_ACK);
	    if (Client[i].minor_version >= 3) {
		write_socket_int(Client[i].socket, rid);
	    }
	    Bleh("server_dir: %d %s", rid, dir_info->name);
	    write_socket_string(Client[i].socket, dir_info->name);
	    write_socket_string(Client[i].socket, dir_info->summary);
	    write_socket_string(Client[i].socket, dir_info->owner);
	    write_socket_int(Client[i].socket, dir_info->priority);
	    write_socket_int(Client[i].socket, dir_info->messagenumber);
	    write_socket_int(Client[i].socket, dir_info->new_messages);
	    write_socket_int(Client[i].socket, dir_info->class);
	    write_socket_int(Client[i].socket, dir_info->default_expiration);
	    write_socket_int(Client[i].socket, dir_info->default_class);
	    write_socket_group_set(Client[i].socket, &dir_info->groups);
	    if (Client[i].minor_version >= 1) {
		write_socket_int(Client[i].socket, dir_info->archive);
	    }
	}
    }
    write_socket_code(Client[i].socket, SERVER_EOF);
    Client[i].update_directory = Directory_stamp;
}
