#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/group_list.c,v 1.4 1999/03/14 23:14:34 kc Exp $")

#include "server.h"

void server_grouplist(int i)
{
  char group[GROUP_SIZE];
  bb_gid gid;
  group_info *groupinfo;
  DbUser db_user;
  bb_uid uid;
  char *id;
  bb_priority group_priority;
  class_t group_class;

  read_socket_s(Client[i].socket, group, sizeof(group));
  if((gid = get_gid(group))==-1)
    SERVER_ERROR("no such group");
  if(!(groupinfo = get_group_info(i, gid)))
    SERVER_ERROR("error accessing group/user information");
  if(NO_ACCESS(groupinfo->class) && !Client[i].owner)
    SERVER_ERROR("permission denied");
  for(uid = 0; uid <= Last_uid; uid++) {
    if(uid == Client[i].uid) {
      id = Client[i].id;
      group_priority = Client[i].group_priority[gid];
      group_class = Client[i].group_class[gid];
    } else {
      if(!get_db_user(&db_user, uid)) continue;
      /*
       * This is a vaguely silly place to put user expiration, but,
       * nevertheless, here it is.  I wanted it somewhere where it
       * isn't performed too often--yet, often enough.
       */
      if(Now - db_user.last_access_time > USER_EXPIRATION_PERIOD)
	remove_user(uid);
      id = db_user.id;
      group_priority = db_user.group_priority[gid];
      group_class = db_user.group_class[gid];
    }
    if(group_class != no_class) {
      write_socket_code(Client[i].socket, SERVER_ACK);
      write_socket_string(Client[i].socket, id);
      write_socket_int(Client[i].socket, group_priority);
      write_socket_int(Client[i].socket, group_class);
    }
  }
  write_socket_code(Client[i].socket, SERVER_EOF);
}
