#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/group_subtract.c,v 1.4 1999/03/14 23:14:35 kc Exp $")

#include "server.h"

/* subtract a room from a group */
void server_groupsubtract(int i)
{
  char group[GROUP_SIZE];
  char room[ROOM_SIZE];
  group_info *groupinfo;
  DbDirectory *db_directory;
  bb_gid gid;
  bb_rid rid;

  read_socket_s(Client[i].socket, group, sizeof(group));
  read_socket_s(Client[i].socket, room, sizeof(room));
  if((gid = get_gid(group))==-1)
    SERVER_ERROR("no such group");
  if((rid = get_rid(room))==-1)
    SERVER_ERROR("no such room");
  if (!(db_directory = get_db_room_directory(rid)))
    SERVER_ERROR("error accessing room information");
  if(!(groupinfo = get_group_info(i, gid)))
    SERVER_ERROR("error accessing group/user information");
  if(!(Client[i].owner || WRITE_ACCESS(groupinfo->class) ||
       (Client[i].uid == db_directory->owner_uid &&
	READ_ACCESS(groupinfo->class))))
    SERVER_ERROR("permission denied");
  GROUP_CLR(gid, &db_directory->groups);
  /* don't need to store summary */
  if(!put_db_room(rid))
    SERVER_ERROR("error storing group information");
  write_socket_code(Client[i].socket, SERVER_ACK);
}
