#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/message_info.c,v 1.4 1999/03/14 23:14:37 kc Exp $")

#include "server.h"
#include <sys/errno.h>

void server_db_message(int i)
{
    int rid;
    DbMessage *db_message;
    int code, num_msgs;
    int message, range_start, range_end;
    DbRoom *db_room;

    read_socket_int(Client[i].socket, &rid);
    read_socket_int(Client[i].socket, &code);
    read_socket_int(Client[i].socket, &range_start);
    if (code == SERVER_MESSAGE_RANGE)
	read_socket_int(Client[i].socket, &range_end);
    else
	range_end = range_start;
    if (!(db_room = get_db_room(Client[i].rid)))
	SERVER_ERROR("error accessing room summary");
    num_msgs = db_room->directory->num_msgs;
    for (message = 0;
	 message < num_msgs &&
	 db_room->summary[message]->number < range_start;
	 message++);
    while (message < num_msgs &&
	   db_room->summary[message]->number <= range_end) {
	db_message = &db_room->summary[message]->header;
	if (!db_message->deleted) {
	    write_socket_code(Client[i].socket, SERVER_ACK);
	    write_socket_int(Client[i].socket,
			     db_room->summary[message]->number);
	    write_socket_int(Client[i].socket, db_message->date);
	    write_socket_int(Client[i].socket, db_message->lines);
	    write_socket_string(Client[i].socket, db_message->poster_id);
	    write_socket_string(Client[i].socket,
				get_id(db_message->poster_uid));
	    write_socket_string(Client[i].socket, db_message->poster_nick);
	    write_socket_string(Client[i].socket, db_message->subject);
	    write_socket_int(Client[i].socket, db_message->expiration);
	}
	message++;
    }
    write_socket_code(Client[i].socket, SERVER_EOF);
}
