#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/message_numbers.c,v 1.4 1999/03/14 23:14:38 kc Exp $")

#include "server.h"
#include <sys/errno.h>

void server_message_numbers(int i)
{
    DbSummary *db_summary;
    DbMessage *db_message;
    DbRoom *db_room;
    int rid, message;
    int start_range = -1, end_range = -1;

    read_socket_int(Client[i].socket, &rid);
    if (Client[i].rid == -1)
	SERVER_ERROR("no room selected");
    if (DAEMON(Client[i].uid))
	SERVER_ERROR("permission denied");
    /* expire_messages(Client[i].rid); */
    if (!(db_room = get_db_room(Client[i].rid)))
	SERVER_ERROR("error accessing room summary");
    if (Client[i].update_message_numbers == db_room->version) {
	write_socket_code(Client[i].socket, SERVER_NAK);
	return;
    }
    for (message = 0;
	 message < db_room->directory->num_msgs;
	 message++) {
      db_summary = db_room->summary[message];
	db_message = &(db_summary->header);
	if (!db_message->deleted) {
	    if(start_range == -1) {
		start_range = db_summary->number;
	    } else if(db_summary->number - end_range > 1) {
		if (start_range == end_range) {
		    write_socket_code(Client[i].socket, SERVER_MESSAGE_SINGLE);
		    write_socket_int(Client[i].socket, start_range);
		} else {
		    write_socket_code(Client[i].socket, SERVER_MESSAGE_RANGE);
		    write_socket_int(Client[i].socket, start_range);
		    write_socket_int(Client[i].socket, end_range);
		}
		start_range = db_summary->number;
	    }
	    end_range = db_summary->number;
	} else {
	    if (start_range != -1) {
		if (start_range == end_range) {
		    write_socket_code(Client[i].socket, SERVER_MESSAGE_SINGLE);
		    write_socket_int(Client[i].socket, start_range);
		} else {
		    write_socket_code(Client[i].socket, SERVER_MESSAGE_RANGE);
		    write_socket_int(Client[i].socket, start_range);
		    write_socket_int(Client[i].socket, end_range);
		}
		start_range = -1;
	    }
	}
    }
    if (start_range != -1) {
	if (start_range == end_range) {
	    write_socket_code(Client[i].socket, SERVER_MESSAGE_SINGLE);
	    write_socket_int(Client[i].socket, start_range);
	} else {
	    write_socket_code(Client[i].socket, SERVER_MESSAGE_RANGE);
	    write_socket_int(Client[i].socket, start_range);
	    write_socket_int(Client[i].socket, end_range);
	}
	start_range = -1;
    }
    write_socket_code(Client[i].socket, SERVER_EOF);
    Client[i].update_message_numbers = db_room->version;
}
