#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/post.c,v 1.5 1999/08/07 00:36:30 kc Exp $")

#include "server.h"
#include <sys/file.h>

void server_post(int i)
{
  DbRoom *db_room;
  DbDirectory *db_directory;
  FILE *write_file;
  char filename[BUFFER_SIZE];
  char *buf = NULL, *c;
  DbMessage message;
  int number;

  if(Read_only)
    SERVER_ERROR("Messagebase is read only.");
  if(Client[i].rid == -1)
    SERVER_ERROR("no room selected");
  if(!WRITE_ACCESS(get_class(i, Client[i].rid)))
    SERVER_ERROR("permission denied");
  if (!(db_room = get_db_room(Client[i].rid)))
    SERVER_ERROR("error accessing room information");
  if(!(db_directory = get_db_room_directory(Client[i].rid)))
    SERVER_ERROR("error accessing room information");
  number = db_directory->next_message_number++;
  sprintf(filename, ACTIVE_MESSAGE, (int)db_directory->arid, number);
  write_file = fopen(filename, "w+");
  if(!write_file) {
    /* maybe directory does not exist? (sys-admin error? ) */
    sprintf(filename, ACTIVE_ROOM, (int)db_directory->arid);
    if (mkdir(filename, 0777) >= 0 ) {
      sprintf(filename, ACTIVE_MESSAGE, (int)db_directory->arid, number);
      write_file = fopen(filename, "w+");
    }
    if (!write_file) {
      syslog(LOG_ERR, "posting %s: %m", filename);
      SERVER_ERROR("error opening output file");
    }
  }
        
  bzero(&message, sizeof(message));
  message.date = time(0);
  message.expiration = message.date + db_directory->default_expiration;
  message.deleted = FALSE;
  message.poster_uid = Client[i].uid;
  bcopy(Client[i].id, message.poster_id, ID_SIZE);
  bcopy(Client[i].nick, message.poster_nick, LINE_SIZE);
  write_socket_code(Client[i].socket, SERVER_ACK);
  read_socket_s(Client[i].socket, message.subject, sizeof(message.subject));
  message.size = read_socket_buf(Client[i].socket, &buf);
  fwrite(buf, message.size, 1, write_file);
  fclose(write_file);
  message.lines = 0;

  if (buf) {
    for(c=buf; c<buf+message.size; c++)
      if(*c == '\n') message.lines++;
    /* null-message ABR 9/95, dmy */
    if(message.size <= 0 || *(--c) != '\n')
      message.lines++;
    free(buf);
  }


#warning INSTALL THIS NEW PATCH 3/22/96
  while (db_directory->num_msgs >= MAX_MESSAGES) {
    DbSummary **sum_info = db_room->summary;
    int post_number = sum_info[0]->number;
    int num_msgs = db_directory->num_msgs;

    if (expire_message(Client[i].rid, post_number))
      syslog(LOG_WARNING, "post (%d, %d): Room Size Forces Expiration",
	     Client[i].rid, post_number);
    else {
      syslog(LOG_ERR, "post (%d, %d): Forced Expiration Failed",
	     Client[i].rid, post_number);
    }
    if (db_directory->num_msgs >= num_msgs) {
      syslog(LOG_ERR, "post (%d): num_msgs (%d) Not Decreasing",
	     Client[i].rid, num_msgs);
      break;
    }
  }
#warning END OF NEW PATCH 3/22/96

  if(!put_db_message(Client[i].rid, number, &message)) {
    SERVER_ERROR("error storing message information");
  }
  update_cached_room_user_info(Client[i].rid, -1);
  write_socket_code(Client[i].socket, SERVER_ACK);
  Client[i].posts++;
}
