#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/preserve.c,v 1.6 1999/03/14 23:14:39 kc Exp $")

#include "server.h"

void server_preserve(int i)
{
  int message;
  time_t new_expiration;
  DbMessage db_message;
  DbDirectory *db_directory;

  read_socket_int(Client[i].socket, &message);
  read_socket_int(Client[i].socket, (int *) &new_expiration);

  if(!db_get_db_message(&db_message, Client[i].rid, message))
    SERVER_ERROR("no such message");
  if(!MODERATOR_ACCESS(get_class(i, Client[i].rid)) &&
     !Client[i].owner)
    SERVER_ERROR("permission denied");
  if(!(db_directory = get_db_room_directory(Client[i].rid)))
    SERVER_ERROR("error accessing room information");
  if(new_expiration > expiration_limit(db_directory->groups) &&
     !Client[i].owner)
    SERVER_ERROR("expiration period too long");
  if(new_expiration < MIN_EXPIRATION && !Client[i].owner)
    SERVER_ERROR("expiration period too short");
  db_message.expiration = Now + new_expiration;
  if(!put_db_message(Client[i].rid, message, &db_message))
    SERVER_ERROR("error storing message information");
  write_socket_code(Client[i].socket, SERVER_ACK);
}
