#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/read.c,v 1.7 1999/08/07 00:36:31 kc Exp $")

#include "server.h"
#include <sys/errno.h>
#include <sys/stat.h>
#include <fcntl.h>

void server_read(int i)
{
  int read_file;
  int message;
  struct stat filestat;
  char *buf;
  char filename[BUFFER_SIZE];
  DbMessage db_message;
  int l;

  read_socket_int(Client[i].socket, &message);
  if(DAEMON(Client[i].uid))
    SERVER_ERROR("permission denied");
  if(!db_get_db_message(&db_message, Client[i].rid, message)) {
    write_socket_code(Client[i].socket, SERVER_NAK);
    return;
  }
  if(db_message.deleted) {
    write_socket_code(Client[i].socket, SERVER_NAK);
    return;
  }
  sprintf(filename, ACTIVE_MESSAGE, get_db_room_arid(Client[i].rid), message);
  read_file=open(filename, O_RDONLY);
  if(read_file == -1) {
    if(errno != ENOENT)
      SERVER_ERROR(sys_errlist[errno]);
    /* message file not found:  remove message entry */
    remove_db_message(Client[i].rid, message);
    write_socket_code(Client[i].socket, SERVER_NAK);
    return;
  }
  if(fstat(read_file, &filestat)!=0) {
    write_socket_code(Client[i].socket, SERVER_NAK);
    close(read_file);
    return;
  }
  buf = (char *) malloc(MAX(filestat.st_size, 1));
errno=0;
  l = read(read_file, buf, filestat.st_size);
  close(read_file);
  if(l!=filestat.st_size) {
#ifdef DEBUG
  if (Debug) {
    fprintf(stderr, "Read returned %d\n", l);
    perror(filename);
  }
#endif DEBUG
    syslog(LOG_ERR, "reading %s: %m", filename);
    write_socket_code(Client[i].socket, SERVER_NAK);
    free(buf);
    return;
  }
  write_socket_code(Client[i].socket, SERVER_ACK);
  write_socket_int(Client[i].socket, message);
  write_socket_int(Client[i].socket, db_message.date);
  write_socket_int(Client[i].socket, db_message.expiration);
  write_socket_int(Client[i].socket, db_message.lines);
  write_socket_string(Client[i].socket, db_message.poster_id);
  write_socket_string(Client[i].socket, get_id(db_message.poster_uid));
  write_socket_string(Client[i].socket, db_message.poster_nick);
  write_socket_string(Client[i].socket, db_message.subject);
  write_socket(Client[i].socket, buf, l);
  free(buf);
  if(message > Client[i].last_message_read)
    update_room_pointer(i, Client[i].rid, message);
}
