#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/rename.c,v 1.4 1999/03/14 23:14:42 kc Exp $")

#include "server.h"

void server_rename(int i)
{
  char new_name[ROOM_SIZE];
  DbDirectory *db_directory;

  read_socket_s(Client[i].socket, new_name, sizeof(new_name));
  if(Client[i].rid == -1)
    SERVER_ERROR("no room selected");
  if(get_rid(new_name) != -1)
    SERVER_ERROR("room already exists");
  if (!(db_directory = get_db_room_directory(Client[i].rid)))
    SERVER_ERROR("error accessing room information");
  if(Client[i].uid != db_directory->owner_uid && !Client[i].owner)
    SERVER_ERROR("permission denied");
  if(!put_rid(new_name, Client[i].rid))
    SERVER_ERROR("error storing new room name");
  if(!remove_rid(db_directory->name))
    SERVER_ERROR("error removing old room name");
  strcpy(db_directory->name, new_name);
 
  /* doesn't really need to update summary file... */  
  if (!(put_db_room(Client[i].rid)))
    SERVER_ERROR("error storing updated room information");
  write_socket_code(Client[i].socket, SERVER_ACK);
}
