#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/search.c,v 1.4 1999/03/14 23:14:43 kc Exp $")

#include "server.h"
#include <sys/errno.h>
#include <sys/stat.h>
#include <fcntl.h>

void server_search(int i)
{
  int read_file, l, size = -1;
  bb_rid rid;
  struct stat filestat;
  char room[ROOM_SIZE], regexp[BUFFER_SIZE], *buf, filename[BUFFER_SIZE];
  DbSummary *db_summary;
  DbMessage *db_message;
  DbRoom *db_room;
  int msg_index;

  read_socket_s(Client[i].socket, room, sizeof(room));
  read_socket_s(Client[i].socket, regexp, sizeof(regexp));
  if(DAEMON(Client[i].uid))
    SERVER_ERROR("permission denied");
  if((rid=get_rid(room)) == -1)
    SERVER_ERROR("no such room");
  if((buf = (char *)re_comp(regexp)))
    SERVER_ERROR(buf);
  if(!(db_room = get_db_room(rid)))
    SERVER_ERROR("error accessing room summary");
  for (msg_index=0; msg_index<db_room->directory->num_msgs; msg_index++) {
    db_summary = db_room->summary[msg_index];
    db_message = &(db_summary->header);
    if(db_message->deleted) continue;
    sprintf(filename, ACTIVE_MESSAGE,
	    get_db_room_arid(rid), db_summary->number);
    if((read_file=open(filename, O_RDONLY)) == -1) continue;
    if(fstat(read_file, &filestat) != 0 || !filestat.st_size) {
      close(read_file);
      continue;
    }
    if(size == -1) {
      size = filestat.st_size+1;
      buf = (char *) malloc(size);
    } else if(size < filestat.st_size) {
      size = filestat.st_size+1;
      buf = (char *) realloc(buf, size);
    }
    l = read(read_file, buf, filestat.st_size);
    close(read_file);
    if(l!=filestat.st_size) continue;
    *(buf+l) = '\0'; /* Array Bounds Write error here. */
    if(re_exec(buf)!=1) continue; /* Array Bounds Read here 11/95 */
    write_socket_code(Client[i].socket, SERVER_ACK);
    write_socket_int(Client[i].socket, db_summary->number);
  }
  if(size != -1) free(buf);
  write_socket_code(Client[i].socket, SERVER_EOF);
}
