#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/select.c,v 1.4 1999/03/14 23:14:44 kc Exp $")

#include "server.h"

void server_select(int i)
{
    char room[ROOM_SIZE];
    DbDirectory *db_directory = NULL;
    bb_rid rid = -1, old_rid = Client[i].rid;

    read_socket_s(Client[i].socket, room, sizeof(room));
    if (*room) {
      if ((rid = get_rid(room)) == -1)
	SERVER_ERROR("no such room");
      if (!(db_directory = get_db_room_directory(rid)))
	SERVER_ERROR("error accessing room information");
    }
    /* save data from previous room */
    if (!Read_only && !save_room_pointer(i))
	SERVER_ERROR(error_text);
    if (!*room) {
	Client[i].rid = -1;
	write_socket_code(Client[i].socket, SERVER_ACK);
	write_socket_int(Client[i].socket, 0);
	if (Client[i].minor_version >= 4) {
	    write_socket_int(Client[i].socket, Client[i].rid);
	}
    } else {
	DbRoomUser db_room_user;

	Client[i].rid = rid;
	if (!get_db_room_user(&db_room_user, rid, Client[i].uid)) {
	    Client[i].last_message_read =
	      db_directory->first_message_number - 1;
	} else {
	    Client[i].last_message_read =
	      MAX(db_directory->first_message_number - 1,
		  db_room_user.last_message_read);
	}
	if (!Client[i].owner && !READ_ACCESS(get_class(i, rid))) {
	    Client[i].rid = -1;
	    SERVER_ERROR("access denied");
	}
	Client[i].update_summary = -1;
	Client[i].update_message_numbers = -1;
	write_socket_code(Client[i].socket, SERVER_ACK);
	write_socket_int(Client[i].socket, Client[i].last_message_read);
	if (Client[i].minor_version >= 4) {
	    write_socket_int(Client[i].socket, Client[i].rid);
	}
    }
    if (old_rid != -1)
	expire_room(old_rid);
}
