#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/signon.c,v 1.4 1999/03/14 23:14:47 kc Exp $")

#include "server.h"
#include "../lib/misc.h"

void server_signon(int i)
{
    DbUser db_user;
    char passwd[10];
    boolean create_flag;
    bb_gid gid;
    bb_rid rid;

    read_socket_s(Client[i].socket, Client[i].user, sizeof(Client[i].user));
    read_socket_s(Client[i].socket, Client[i].id, sizeof(Client[i].id));
    Client[i].uid = get_uid(Client[i].id);
    read_socket_s(Client[i].socket, passwd, sizeof(passwd));
    read_socket(Client[i].socket, &create_flag, sizeof(create_flag));
    if (Client[i].uid == -1 || !get_db_user(&db_user, Client[i].uid)) {
	char saltc[2];
	time_t salt;
	int c, j;

	if (!create_flag)
	    SERVER_ERROR("no signon exists under that id");

    /* new user:  use default values */
	Client[i].uid = add_uid(Client[i].id);
	bzero((char *)&db_user, sizeof(db_user));
	strcpy(db_user.id, Client[i].id);
	time(&salt);
	saltc[0] = salt & 077;
	saltc[1] = (salt >> 6) & 077;
	for (j = 0; j < 2; j++) {
	    c = saltc[j] + '.';
	    if (c > '9')
		c += 7;
	    if (c > 'Z')
		c += 6;
	    saltc[j] = c;
	}
	strcpy(db_user.passwd, (char *)crypt(passwd, saltc));
	db_user.uses = 0;
	db_user.posts = 0;
	db_user.connect_time = 0;
	db_user.cutoff_priority = DEFAULT_CUTOFF_PRIORITY;
	for (gid = 0; gid < MAX_GROUPS; gid++) {
	    db_user.group_priority[gid] = 0;
	    db_user.group_class[gid] = no_class;
	}
	{
	  /* record new entry */
	  FILE *dump_f;
	  if ((dump_f = fopen(STARTUP_USERS, "a"))) {
	    fprintf(dump_f, "%4d (%s) (NEW)\n",
		    (int)Client[i].uid, Client[i].id);
	    fclose(dump_f);
	  }
	}
    } else {
	if (create_flag)
	    SERVER_ERROR("that id is already in use");
    }
    if (strcmp((char *)crypt(passwd, db_user.passwd), db_user.passwd) != 0)
	SERVER_ERROR("incorrect password");
    db_user.uses++;
    db_user.last_access_time = time(0);
    sprintf(db_user.last_access_source, "%s@%s",
	    Client[i].user, Client[i].host);

    if (!Read_only && !put_db_user(Client[i].uid, &db_user))
	SERVER_ERROR("error storing user information");
    write_socket_code(Client[i].socket, SERVER_ACK);
    write_socket_int(Client[i].socket, db_user.cutoff_priority);

    strcpy(Client[i].address, db_user.last_access_source);
    strcpy(Client[i].nick, db_user.nick);
    Client[i].signon_time = db_user.last_access_time;
    Client[i].cutoff_priority = db_user.cutoff_priority;
    Client[i].signed_on = TRUE;
    Client[i].posts = 0;
    Client[i].owner = OWNER(Client[i].uid);
    Client[i].update_directory = 0;
    Client[i].update_summary = -1;
    Client[i].update_message_numbers = -1;
    Client[i].rid = -1;
    {
      int pad_Last_rid = pad_up_to_25_pct(Last_rid + 1);
      Client[i].dir_info = (Last_rid >= 0) ?
	(directory_info **) malloc(pad_Last_rid * sizeof(directory_info *)) :
	  NULL;
      Client[i].stamp = (Last_rid >= 0) ? (struct client_stamp *)
	malloc(pad_Last_rid * sizeof(struct client_stamp)) : NULL;
    }
    for (rid = 0; rid <= Last_rid; rid++) {
	Client[i].dir_info[rid] = NULL;
	Client[i].stamp[rid].update = 1;
	Client[i].stamp[rid].sent = 0;
    }
    for (gid = 0; gid <= Last_gid; gid++) {
	DbGroup db_group;
	
	Client[i].group_priority[gid] = db_user.group_priority[gid];
	if (get_db_group(&db_group, gid))
	  Client[i].group_priority[gid] += db_group.group_offset;
	Client[i].group_class[gid] = db_user.group_class[gid];
    }
}
