#include "../lib/rcsid.h"

RCS_ID("$Header: /NetworkDisk/Source/CVS/Staff/kc/bb/server/undelete.c,v 1.6 1999/03/14 23:14:48 kc Exp $")

#include "server.h"

void server_undelete(int i)
{
  int message;
  DbMessage db_message;

  read_socket_int(Client[i].socket, &message);
  if(DAEMON(Client[i].uid))
    SERVER_ERROR("permission denied");
  if(!db_get_db_message(&db_message, Client[i].rid, message))
    SERVER_ERROR("no such message");
  if(Client[i].uid != db_message.poster_uid &&
     !MODERATOR_ACCESS(get_class(i, Client[i].rid)) &&
     !Client[i].owner)
    SERVER_ERROR("permission denied");
  if(Client[i].uid != db_message.poster_uid &&
     !DAEMON(db_message.poster_uid)) {
    char subject[LINE_SIZE];
    FILE *message_f;
    const char *room = get_roomname(Client[i].rid);

    sprintf(subject, "%s #%d undeleted by <%s>",
	    room, message, Client[i].id);
    if ((message_f = mail(Client[i].uid, db_message.poster_uid, subject))) {
      fprintf(message_f,
	      "Your posting #%d in room %s was undeleted by <%s> (%d)\n",
	      message, room, Client[i].id, (int)Client[i].uid);
      pclose(message_f);
    }
  }
  db_message.deleted = 0;
  if(!put_db_message(Client[i].rid, message, &db_message)) 
    SERVER_ERROR("database error undeleting message");
  if(!put_db_room(Client[i].rid))
    SERVER_ERROR("error storing room information");
  write_socket_code(Client[i].socket, SERVER_ACK);
  return;
}
